#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

typedef union qw_u
{
    float f[4];
    unsigned int i[4];
} qw;

qw data[1023];

void error(int num)
{
    printf("Error %d\n", num);
    exit(num);
}

int main(int argc, char *argv[])
{
    int fd;

    bzero(data,sizeof(data));

    data[0].i[0]=0x00008000; data[0].i[1]=0x00000000; data[0].i[2]=0x00000000; data[0].i[3]=0x00000000;

#define stall 0
#define campos 1
#define camdir 2
#define vpmul 3
#define vpadd 4
#define pmtx 5
#define shippos 9
#define shipdeltapos 10
#define shipdeltaposacc 11
#define shipdeltaposdec 12
#define shipdeltaposmin 13
#define shipdeltaposmax 14
#define offset 15
#define delta 16
#define score 17
#define pausecount 17
#define boostcount 17

#define ring0 100
#define ring1 111
#define ring2 122
#define ring3 133
#define ring4 144
#define ring5 155
#define ring6 166
#define ring7 177
#define ring8 188
#define ring9 199
#define ring10 210
#define ring11 221
#define ring12 232
#define ring13 243
#define ring14 254
#define ring15 265
#define blendfracs 276
#define palette 292
#define map 442
#define ringgiftag 592
#define shipgiftag 593
#define ship 594
#define fontparts 618
#define fontgiftag 650
#define bonusgiftag 651
#define bonuses 652
#define bonus1 712
#define bonus2 732

#define outpos 900

#define zfar 100000.0f
#define znear 0.01f
#define zdist (zfar-znear)

    data[vpmul].f[0]=-640.0f/2.0f;
    data[vpmul].f[1]=224.0f/2.0f;
    data[vpmul].f[2]=zdist/2.0f;
    data[vpmul].f[3]=1.0f;
    data[vpadd].f[0]=2048.0f;
    data[vpadd].f[1]=2048.0f-20.0f;
    data[vpadd].f[2]=(zfar+znear)/2.0f;
    data[vpadd].f[3]=0.0f;

    data[pmtx+0].f[0]=1.732f/(640.0f/448.0f);
    data[pmtx+0].f[1]=0.0f;
    data[pmtx+0].f[2]=0.0f;
    data[pmtx+0].f[3]=0.0f;
    data[pmtx+1].f[0]=0.0f;
    data[pmtx+1].f[1]=1.732f;
    data[pmtx+1].f[2]=0.0f;
    data[pmtx+1].f[3]=0.0f;
    data[pmtx+2].f[0]=0.0f;
    data[pmtx+2].f[1]=0.0f;
    data[pmtx+2].f[2]=-(znear+zfar)/zdist;
    data[pmtx+2].f[3]=-1.0f;
    data[pmtx+3].f[0]=0.0f;
    data[pmtx+3].f[1]=0.0f;
    data[pmtx+3].f[2]=-(znear*zfar*2.0f)/zdist;
    data[pmtx+3].f[3]=0.0f;

    data[campos].f[0]=0.0f;
    data[campos].f[1]=-5.0f;
    data[campos].f[2]=0.0f;

    data[camdir].f[0]=0.0f;
    data[camdir].f[1]=0.0f;
    data[camdir].f[2]=1.0f;

    data[shippos].f[0]=0.0f;
    data[shippos].f[1]=-7.0f;
    data[shippos].f[2]=20.0f;

    data[shipdeltapos].f[0]=0.0f;
    data[shipdeltapos].f[1]=0.0f;
    data[shipdeltapos].f[2]=0.0f;

    data[shipdeltaposacc].f[0]=0.024f;
    data[shipdeltaposacc].f[1]=0.017f;
    data[shipdeltaposacc].f[2]=0.0f;

    data[shipdeltaposdec].f[0]=0.012f;
    data[shipdeltaposdec].f[1]=0.010f;
    data[shipdeltaposdec].f[2]=0.0f;

    data[shipdeltaposmin].f[0]=-0.4f*1.33f;
    data[shipdeltaposmin].f[1]=-0.3f*1.33f;
    data[shipdeltaposmin].f[2]=1.0f;

    data[shipdeltaposmax].f[0]=0.4f*1.33f;
    data[shipdeltaposmax].f[1]=0.4f*1.33f;
    data[shipdeltaposmax].f[2]=1.5f;

    data[offset].f[0]=0.0f;
    data[offset].f[1]=0.0f;
    data[offset].f[2]=10.0f;

    data[score].f[0]=0.0f;
    data[pausecount].i[1]=0;
    data[boostcount].i[2]=0;

    data[delta].f[0]=0.0f;
    data[delta].f[1]=0.0f;
    data[delta].f[2]=8.0f;

    {
	#include "rings.h"
	bcopy(r0points,&data[ring0].f[0],sizeof(r0points));
	bcopy(r1points,&data[ring1].f[0],sizeof(r1points));
	bcopy(r2points,&data[ring2].f[0],sizeof(r2points));
	bcopy(r3points,&data[ring3].f[0],sizeof(r3points));
	bcopy(r4points,&data[ring4].f[0],sizeof(r4points));
	bcopy(r5points,&data[ring5].f[0],sizeof(r5points));
	bcopy(r6points,&data[ring6].f[0],sizeof(r6points));
	bcopy(r7points,&data[ring7].f[0],sizeof(r7points));
	bcopy(r8points,&data[ring8].f[0],sizeof(r8points));
	bcopy(r9points,&data[ring9].f[0],sizeof(r9points));
	bcopy(r10points,&data[ring10].f[0],sizeof(r10points));
	bcopy(r11points,&data[ring11].f[0],sizeof(r11points));
	bcopy(r12points,&data[ring12].f[0],sizeof(r12points));
	bcopy(r13points,&data[ring13].f[0],sizeof(r13points));
	bcopy(r14points,&data[ring14].f[0],sizeof(r14points));
	bcopy(r15points,&data[ring15].f[0],sizeof(r15points));
    }

    {
	#define SHIPSCALE 0.15f
//	#define SX1 -8.0f*SHIPSCALE
//	#define SX2 -5.0f*SHIPSCALE
//	#define SX3  5.0f*SHIPSCALE
//	#define SX4  8.0f*SHIPSCALE
//	#define SY1 -2.0f*SHIPSCALE
//	#define SY2 -1.7f*SHIPSCALE
//	#define SY3  1.7f*SHIPSCALE
//	#define SY4  2.0f*SHIPSCALE
//	#define SZ1 -9.0f*SHIPSCALE
//	#define SZ2  9.0f*SHIPSCALE
	
	#define SX1 -10.0f*SHIPSCALE
	#define SX2  0.0f*SHIPSCALE
	#define SX3  10.0f*SHIPSCALE
	#define SY1 -1.5f*SHIPSCALE
	#define SY2  0.0f*SHIPSCALE
	#define SY3  1.5f*SHIPSCALE
	#define SZ1 -9.0f*SHIPSCALE
	#define SZ2 15.0f*SHIPSCALE

	typedef struct shipdat_s
	{
	    float pos[4];
	    unsigned int col[4];
	} shipdat;

	shipdat shipdata[10] =
	{
//	    {{SX1, SY1, SZ1}, {0,0,0}},
//	    {{SX2, SY2, SZ2}, {0,0,0}},
//	    {{SX1, SY4, SZ1}, {0,64,64}},
//	    {{SX2, SY3, SZ2}, {0,64,64}},
//	    {{SX4, SY4, SZ1}, {0,127,127}},
//	    {{SX3, SY3, SZ2}, {0,127,127}},
//	    {{SX4, SY1, SZ1}, {0,64,64}},
//	    {{SX3, SY2, SZ2}, {0,64,64}},
//	    {{SX1, SY1, SZ1}, {0,127,127}},
//	    {{SX2, SY2, SZ2}, {0,127,127}},
//	    {{SX4, SY4, SZ1}, {0,0,0}},
//	    {{SX4, SY1, SZ1}, {0,0,0}},
//	    {{SX1, SY4, SZ1}, {192,160,16}},
//	    {{SX1, SY1, SZ1}, {192,160,16}},

	    #define SHIPCOL1 {0,64,64}
	    #define SHIPCOL2 {0,127,127}
	    #define SHIPCOL3 {192,160,16}
	    {{SX2, SY2, SZ2}, SHIPCOL1},
	    {{SX1, SY2, SZ1}, SHIPCOL1},
	    {{SX2, SY3, SZ1}, SHIPCOL1},
	    {{SX2, SY1, SZ1}, SHIPCOL3},
	    {{SX3, SY2, SZ1}, SHIPCOL3},
	    {{SX2, SY2, SZ2}, SHIPCOL1},
	    {{SX2, SY3, SZ1}, SHIPCOL2},
	    {{SX1, SY2, SZ1}, SHIPCOL1},
	    {{SX2, SY1, SZ1}, SHIPCOL3},
	    {{SX2, SY2, SZ2}, SHIPCOL2},
	};
	bcopy(shipdata,&data[ship].f[0],sizeof(shipdata));
    }

    {
	#define BONUSSCALE 0.3f
	
	#define BX1 -9.0f*BONUSSCALE
	#define BX2 -3.0f*BONUSSCALE
	#define BX3  0.0f*BONUSSCALE
	#define BX4  3.0f*BONUSSCALE
	#define BX5  9.0f*BONUSSCALE
	#define BY1 -8.0f*BONUSSCALE
	#define BY2  0.0f*BONUSSCALE
	#define BY3  8.0f*BONUSSCALE
	#define BZ1  9.0f*BONUSSCALE
	#define BZ2 -9.0f*BONUSSCALE

	typedef struct bonusdat_s
	{
	    float pos[4];
	    unsigned int col[4];
	} bonusdat;

	bonusdat bonus1data[10] =
	{
	    #define BONUSCOL1 {255,127,127}
	    #define BONUSCOL2 {255,255,127}
	    {{BX1, BY2, BZ1}, BONUSCOL1},
	    {{BX2, BY3, BZ1}, BONUSCOL1},
	    {{BX3, BY2, BZ2}, BONUSCOL1},
	    {{BX4, BY3, BZ1}, BONUSCOL2},
	    {{BX5, BY2, BZ1}, BONUSCOL1},
	    {{BX3, BY2, BZ2}, BONUSCOL1},
	    {{BX4, BY1, BZ1}, BONUSCOL2},
	    {{BX2, BY1, BZ1}, BONUSCOL1},
	    {{BX3, BY2, BZ2}, BONUSCOL1},
	    {{BX1, BY2, BZ1}, BONUSCOL2},
	};

	bonusdat bonus2data[10] =
	{
	    #define BONUSCOL3 {127,255,127}
	    #define BONUSCOL4 {127,127,255}
	    {{BX1, BY2, BZ1}, BONUSCOL3},
	    {{BX2, BY3, BZ1}, BONUSCOL3},
	    {{BX3, BY2, BZ2}, BONUSCOL3},
	    {{BX4, BY3, BZ1}, BONUSCOL4},
	    {{BX5, BY2, BZ1}, BONUSCOL3},
	    {{BX3, BY2, BZ2}, BONUSCOL3},
	    {{BX4, BY1, BZ1}, BONUSCOL4},
	    {{BX2, BY1, BZ1}, BONUSCOL3},
	    {{BX3, BY2, BZ2}, BONUSCOL3},
	    {{BX1, BY2, BZ1}, BONUSCOL4},
	};

	typedef struct bonuspos_s
	{
	    float pos[3];
	    int type;
	} bonuspos;

	bonuspos bonuspositions[60] =
	{
	    {  0.0f,  0.0f,  3.0f,  1},
	    {  0.0f,  0.0f,  4.0f,  1},
	    { 10.0f,  0.0f,  5.0f,  1},
	    { 20.0f,  5.0f,  6.0f,  1},
	    { 25.0f,  8.0f,  7.0f,  1},
	    { 40.0f,  0.0f,  8.0f, 21},
	    { 34.0f,  2.0f,  9.0f,  1},
	    { 28.0f,  5.0f, 10.0f,  1},
	    { 18.0f, 10.0f, 11.0f,  1},
	    { 18.0f, 13.0f, 12.0f,  1},
	    {  6.0f, 20.0f, 13.0f, 21},
	    {  0.0f, 15.0f, 14.0f,  1},
	    { -5.0f, 13.0f, 15.0f,  1},
	    {-10.0f,  3.0f, 16.0f,  1},
	    {  2.0f, 10.0f, 17.0f,  1},
	    { -6.0f,  5.0f, 18.0f, 21},
	    {  0.0f,  3.0f, 19.0f,  1},
	    { 20.0f,  0.0f, 20.0f,  1},
	    { 40.0f,  0.0f, 21.0f,  1},
	    { 55.0f,  5.0f, 22.0f,  1},
	    { 60.0f, 20.0f, 23.0f,  1},
	    { 60.0f, 40.0f, 24.0f, 21},
	    { 55.0f, 55.0f, 25.0f,  1},
	    { 40.0f, 60.0f, 26.0f,  1},
	    { 20.0f, 60.0f, 27.0f,  1},
	    {  5.0f, 55.0f, 28.0f,  1},
	    {  0.0f, 40.0f, 29.0f, 21},
	    {  5.0f, 20.0f, 30.0f,  1},
	    { 12.0f,  0.0f, 31.0f,  1},
	    {  4.0f, 10.0f, 32.0f,  1},
	    {-13.0f, 25.0f, 33.0f,  1},
	    { -1.0f, 20.0f, 34.0f, 21},
	    { 15.0f, 10.0f, 35.0f,  1},
	    {  2.0f,  5.0f, 36.0f,  1},
	    { 10.0f, 15.0f, 37.0f,  1},
	    { 10.0f, 15.0f, 37.5f, 21},
	    { 10.0f, 10.0f, 38.0f,  1},
	    { 10.0f, 10.0f, 38.5f,  1},
	    { -2.0f, 20.0f, 39.0f,  1},
	    { -2.0f, 20.0f, 39.5f,  1},
	    { -4.0f, 23.0f, 40.0f, 21},
	    { -4.0f, 23.0f, 40.5f,  1},
	    {  6.0f, 10.0f, 41.0f,  1},
	    {  6.0f, 10.0f, 41.5f,  1},
	    {  5.0f, 14.0f, 42.0f, 21},
	    {  5.0f, 14.0f, 42.5f,  1},
	    {  3.0f, 18.0f, 43.0f,  1},
	    {  3.0f, 18.0f, 43.5f,  1},
	    {  2.0f, 22.0f, 44.0f, 21},
	    {  2.0f, 22.0f, 44.5f,  1},
	    {  0.0f, 27.0f, 45.0f,  1},
	    {  0.0f, 27.0f, 45.5f, 21},
	    {  0.0f, 30.0f, 46.0f,  1},
	    {  0.0f, 30.0f, 46.5f,  1},
	    {  4.0f, 12.0f, 47.0f,  1},
	    {  4.0f, 12.0f, 47.5f, 21},
	    {  2.0f,  6.0f, 48.0f,  1},
	    {  2.0f,  6.0f, 48.5f,  1},
	    {  0.0f,  0.0f, 49.0f, 21},
	    {  0.0f,  0.0f, 49.5f,  1},
	};

	bcopy(bonus1data,&data[bonus1].f[0],sizeof(bonus1data));
	bcopy(bonus2data,&data[bonus2].f[0],sizeof(bonus2data));
	bcopy(bonuspositions,&data[bonuses].f[0],sizeof(bonuspositions));
    }

    {
	#define FONTSCALE 0.05f
	#define FX1 -1.0f*FONTSCALE
	#define FX2 -0.65f*FONTSCALE
	#define FX3 -0.15f*FONTSCALE
	#define FX4 0.15f*FONTSCALE
	#define FX5 0.65f*FONTSCALE
	#define FX6 1.0f*FONTSCALE
	#define FY1 -1.0f*FONTSCALE
	#define FY2 -0.65f*FONTSCALE
	#define FY3 -0.15f*FONTSCALE
	#define FY4 0.15f*FONTSCALE
	#define FY5 0.65f*FONTSCALE
	#define FY6 1.0f*FONTSCALE
	float fontpartsdata[16*4][2]=
	{
	    {FX1, FY3}, {FX1, FY6}, {FX2, FY6}, {FX2, FY3},
	    {FX1, FY1}, {FX1, FY4}, {FX2, FY4}, {FX2, FY1},
	    {FX3, FY1}, {FX3, FY6}, {FX4, FY6}, {FX4, FY1},
	    {FX5, FY3}, {FX5, FY6}, {FX6, FY6}, {FX6, FY3},
	    {FX5, FY1}, {FX5, FY4}, {FX6, FY4}, {FX6, FY1},

	    {FX1, FY5}, {FX4, FY5}, {FX4, FY6}, {FX1, FY6},
	    {FX3, FY5}, {FX6, FY5}, {FX6, FY6}, {FX3, FY6},

	    {FX1, FY3}, {FX4, FY3}, {FX4, FY4}, {FX1, FY4},
	    {FX3, FY3}, {FX6, FY3}, {FX6, FY4}, {FX3, FY4},

	    {FX1, FY1}, {FX4, FY1}, {FX4, FY2}, {FX1, FY2},
	    {FX3, FY1}, {FX6, FY1}, {FX6, FY2}, {FX3, FY2},
	    
	    {FX1, FY2}, {FX3, FY4}, {FX4, FY3}, {FX2, FY1},
	    {FX3, FY4}, {FX5, FY6}, {FX6, FY5}, {FX4, FY3},
	    {FX1, FY5}, {FX2, FY6}, {FX4, FY4}, {FX3, FY3},
	    {FX3, FY3}, {FX4, FY4}, {FX6, FY2}, {FX5, FY1},
	    {FX3, FY5}, {FX4, FY6}, {FX6, FY4}, {FX5, FY3},
	};
	bcopy(fontpartsdata,&data[fontparts].f[0],sizeof(fontpartsdata));
    }

    {
	#include "map.h"
	bcopy(mapdata,&data[map],sizeof(mapdata));
    }

    {
	float bf[16][4] =
	{
	    {15.0f/15.0f,  0.0f/15.0f},
	    {14.0f/15.0f,  1.0f/15.0f},
	    {13.0f/15.0f,  2.0f/15.0f},
	    {12.0f/15.0f,  3.0f/15.0f},
	    {11.0f/15.0f,  4.0f/15.0f},
	    {10.0f/15.0f,  5.0f/15.0f},
	    { 9.0f/15.0f,  6.0f/15.0f},
	    { 8.0f/15.0f,  7.0f/15.0f},
	    { 7.0f/15.0f,  8.0f/15.0f},
	    { 6.0f/15.0f,  9.0f/15.0f},
	    { 5.0f/15.0f, 10.0f/15.0f},
	    { 4.0f/15.0f, 11.0f/15.0f},
	    { 3.0f/15.0f, 12.0f/15.0f},
	    { 2.0f/15.0f, 13.0f/15.0f},
	    { 1.0f/15.0f, 14.0f/15.0f},
	    { 0.0f/15.0f, 15.0f/15.0f},
	};
	bcopy(bf,&data[blendfracs].f[0],sizeof(bf));
    }

    {
	#define PALCOL(a) ((1.0f/4096.0f)*((float)a))
	#define PALCOLS(a,b,c) {PALCOL(a),PALCOL(b),PALCOL(c),PALCOL(0)}
	float pal[150][4]=
	{
	    PALCOLS(0xcf,0xcf,0xcf),
	    PALCOLS(0xdf,0xdf,0xdf),
	    PALCOLS(0xff,0xff,0xff),
	    PALCOLS(0xdf,0xdf,0xdf),
	    PALCOLS(0xcf,0xcf,0xcf),
	    PALCOLS(0x40,0x40,0x40),
	    PALCOLS(0x70,0x70,0x70),
	    PALCOLS(0x80,0x80,0x80),
	    PALCOLS(0x70,0x70,0x70),
	    PALCOLS(0x40,0x40,0x40),
	    PALCOLS(0xcf,0xcf,0xcf),
	    PALCOLS(0xdf,0xdf,0xdf),
	    PALCOLS(0xff,0xff,0xff),
	    PALCOLS(0xdf,0xdf,0xdf),
	    PALCOLS(0xcf,0xcf,0xcf),
	    PALCOLS(0x40,0x40,0x40),
	    PALCOLS(0x70,0x70,0x70),
	    PALCOLS(0x80,0x80,0x80),
	    PALCOLS(0x70,0x70,0x70),
	    PALCOLS(0x40,0x40,0x40),
	    PALCOLS(0xcf,0xcf,0xcf),
	    PALCOLS(0xdf,0xdf,0xdf),
	    PALCOLS(0xff,0xff,0xff),
	    PALCOLS(0xdf,0xdf,0xdf),
	    PALCOLS(0xcf,0xcf,0xcf),
	    PALCOLS(0x40,0x40,0x40),
	    PALCOLS(0x70,0x70,0x70),
	    PALCOLS(0x80,0x80,0x80),
	    PALCOLS(0x70,0x70,0x70),
	    PALCOLS(0x40,0x40,0x40),

	    PALCOLS(0x40,0x40,0x40),
	    PALCOLS(0x68,0x68,0x68),
	    PALCOLS(0x50,0x50,0x50),
	    PALCOLS(0x48,0x48,0x48),
	    PALCOLS(0x58,0x58,0x58),
	    PALCOLS(0x70,0x70,0x70),
	    PALCOLS(0x40,0x40,0x40),
	    PALCOLS(0x60,0x60,0x60),
	    PALCOLS(0x50,0x50,0x50),
	    PALCOLS(0x60,0x60,0x60),
	    PALCOLS(0x40,0x40,0x40),
	    PALCOLS(0x70,0x70,0x70),
	    PALCOLS(0x58,0x58,0x58),
	    PALCOLS(0x60,0x60,0x60),
	    PALCOLS(0x70,0x70,0x70),
	    PALCOLS(0x50,0x50,0x50),
	    PALCOLS(0x68,0x68,0x68),
	    PALCOLS(0x50,0x50,0x50),
	    PALCOLS(0x60,0x60,0x60),
	    PALCOLS(0x70,0x70,0x70),
	    PALCOLS(0x58,0x58,0x58),
	    PALCOLS(0x40,0x40,0x40),
	    PALCOLS(0x70,0x70,0x70),
	    PALCOLS(0x60,0x60,0x60),
	    PALCOLS(0x40,0x40,0x40),
	    PALCOLS(0x68,0x68,0x68),
	    PALCOLS(0x40,0x40,0x40),
	    PALCOLS(0x58,0x58,0x58),
	    PALCOLS(0x60,0x60,0x60),
	    PALCOLS(0x70,0x70,0x70),

	    PALCOLS(0x90,0x90,0x90),
	    PALCOLS(0xb8,0xb8,0xb8),
	    PALCOLS(0xa0,0xa0,0xa0),
	    PALCOLS(0x98,0x98,0x98),
	    PALCOLS(0xa8,0xa8,0xa8),
	    PALCOLS(0xc0,0xc0,0xc0),
	    PALCOLS(0x90,0x90,0x90),
	    PALCOLS(0xb0,0xb0,0xb0),
	    PALCOLS(0xa0,0xa0,0xa0),
	    PALCOLS(0xb0,0xb0,0xb0),
	    PALCOLS(0x90,0x90,0x90),
	    PALCOLS(0xc0,0xc0,0xc0),
	    PALCOLS(0xa8,0xa8,0xa8),
	    PALCOLS(0xb0,0xb0,0xb0),
	    PALCOLS(0xc0,0xc0,0xc0),
	    PALCOLS(0xa0,0xa0,0xa0),
	    PALCOLS(0xb8,0xb8,0xb8),
	    PALCOLS(0xa0,0xa0,0xa0),
	    PALCOLS(0xb0,0xb0,0xb0),
	    PALCOLS(0xc0,0xc0,0xc0),
	    PALCOLS(0xa8,0xa8,0xa8),
	    PALCOLS(0x90,0x90,0x90),
	    PALCOLS(0xc0,0xc0,0xc0),
	    PALCOLS(0xb0,0xb0,0xb0),
	    PALCOLS(0x90,0x90,0x90),
	    PALCOLS(0xb8,0xb8,0xb8),
	    PALCOLS(0x90,0x90,0x90),
	    PALCOLS(0xa8,0xa8,0xa8),
	    PALCOLS(0xb0,0xb0,0xb0),
	    PALCOLS(0xc0,0xc0,0xc0),

	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),

	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	    PALCOLS(0x00,0x00,0x00),
	};
	#define FP00 0x8000
	#define FP01 0x4000
	#define FP02 0x2000
	#define FP03 0x1000
	#define FP04 0x800
	#define FP05 0x400
	#define FP06 0x200
	#define FP07 0x100
	#define FP08 0x80
	#define FP09 0x40
	#define FP10 0x20
	#define FP11 0x10
	#define FP12 0x8
	#define FP13 0x4
	#define FP14 0x2
	#define FP15 0x1
	unsigned int fontdata[10*4]=
	{
	    FP00|FP01|FP09|FP10|FP04|FP03|FP06|FP05|FP11|FP12, // 0
	    FP02,					    // 1
	    FP05|FP06|FP03|FP08|FP11|FP09|FP10,		    // 2
	    FP05|FP06|FP03|FP04|FP10|FP09|FP08,		    // 3
	    FP00|FP07|FP08|FP02,			    // 4
	    FP06|FP05|FP00|FP07|FP08|FP04|FP10|FP09,	    // 5
	    FP06|FP05|FP00|FP07|FP08|FP04|FP10|FP09|FP01,   // 6
	    FP05|FP06|FP12|FP11,			    // 7
	    FP00|FP01|FP09|FP10|FP04|FP03|FP06|FP05|FP07|FP08, // 8
	    FP09|FP10|FP04|FP03|FP06|FP05|FP00|FP07|FP08,   // 9
	    FP01|FP00|FP05|FP06|FP03|FP04|FP07|FP08,	    // A
	    FP01|FP00|FP05|FP15|FP07|FP08|FP14|FP09|FP10,   // B
	    FP06|FP05|FP00|FP01|FP09|FP10,		    // C
	    FP01|FP00|FP05|FP15|FP04|FP10|FP09,		    // D
	    FP06|FP05|FP00|FP01|FP09|FP10|FP07,		    // E
	    FP06|FP05|FP00|FP01|FP07,			    // F
	    FP06|FP05|FP00|FP01|FP09|FP10|FP04|FP08,	    // G
	    FP00|FP01|FP07|FP08|FP03|FP04,		    // H
	    FP02,					    // I
	    FP05|FP06|FP02|FP09,			    // J
	    FP00|FP01|FP07|FP12|FP14,			    // K
	    FP00|FP01|FP09|FP10,			    // L
	    FP01|FP00|FP13|FP12|FP03|FP04,		    // M
	    FP01|FP00|FP13|FP14|FP04|FP03,		    // N
	    FP00|FP01|FP09|FP10|FP04|FP03|FP06|FP05,	    // O
	    FP01|FP00|FP05|FP06|FP03|FP08|FP07,		    // P
	    FP00|FP01|FP09|FP10|FP04|FP03|FP06|FP05|FP14,   // Q
	    FP01|FP00|FP05|FP06|FP03|FP08|FP07|FP14,	    // R
	    FP06|FP05|FP00|FP07|FP08|FP04|FP10|FP09,	    // S
	    FP05|FP06|FP02,				    // T
	    FP00|FP01|FP09|FP10|FP04|FP03,		    // U
	    FP13|FP14|FP04|FP03,			    // V
	    FP00|FP01|FP11|FP14|FP04|FP03,		    // W
	    FP11|FP12|FP13|FP14,			    // X
	    FP00|FP07|FP08|FP03|FP04|FP10|FP09,		    // Y
	    FP05|FP06|FP12|FP11|FP09|FP10,		    // Z
	    FP02|FP07|FP08|FP11|FP12|FP13|FP14,		    // *
	    FP07|FP08,					    // -
	    0,
	    0,						    // SP
	};
	int i;
	bcopy(pal,&data[palette].i[0],sizeof(pal));
	for(i=0;i<40;i++)
	    data[palette+i].i[3]=fontdata[i];
    }

    // flatshaded
    data[ringgiftag+ 0].i[0]=0x0000802a; data[ringgiftag+ 0].i[1]=0x20024000; data[ringgiftag+ 0].i[2]=0x00000051; data[ringgiftag+ 0].i[3]=0x00000000;
    // goraudshaded
    //data[ringgiftag+ 0].i[0]=0x0000802a; data[ringgiftag+ 0].i[1]=0x20064000; data[ringgiftag+ 0].i[2]=0x00000051; data[ringgiftag+ 0].i[3]=0x00000000;

    data[shipgiftag+ 0].i[0]=0x00008007; data[shipgiftag+ 0].i[1]=0x20024000; data[shipgiftag+ 0].i[2]=0x00000051; data[shipgiftag+ 0].i[3]=0x00000000;

    data[fontgiftag+ 0].i[0]=0x00008010; data[fontgiftag+ 0].i[1]=0x20024000; data[fontgiftag+ 0].i[2]=0x00000051; data[fontgiftag+ 0].i[3]=0x00000000;

    data[bonusgiftag+ 0].i[0]=0x0000800a; data[bonusgiftag+ 0].i[1]=0x20024000; data[bonusgiftag+ 0].i[2]=0x00000051; data[bonusgiftag+ 0].i[3]=0x00000000;

    fd=open("frd.dat", O_WRONLY|O_CREAT|O_TRUNC);
    if(fd<0)
	error(1);
    if(write(fd,data,sizeof(data))!=sizeof(data))
	error(2);
    close(fd);
    printf("done\n");
    return(0);
}

