#include <stdio.h>
#include <math.h>
#include "packet.h"

typedef union
{
	u_long128     ul128;
	u_long        ul64[2];
	u_int         ui32[4];
	float         f32[4];
} qword_t;

int main(int argc, char **argv)
{
	FILE *output;
	int bytes=0;
	int prim=0;
	qword_t color;
	qword_t vertex;

	int loop;

	u_long128 packet_data[1024];

	gifpacket_t gifpacket;

	if (argc!=2)
	{
		fprintf(stderr, "Usage: gen_data output_file\n");
		return -1;
	}

	gifpacket_init(&gifpacket, packet_data);

	/* ship */
	prim=GS_SET_PRIM(GS_PRIM_TRI, GOURAUD(1), TEXTURED(0), FOG(0), ABE(0), AA(1), NA(0), CTXT(0), FIX(0));
	gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(6), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
	gifpacket_addgsdata(&gifpacket, 0x51);

	color.ui32[0]=0xFF; color.ui32[1]=0x0; color.ui32[2]=0x0; color.ui32[3]=0x00;
	gifpacket_addgspacked(&gifpacket, color.ul128);
	
	vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(12)<<4; vertex.ui32[2]=4; vertex.ui32[3]=1;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);
	
	color.ui32[0]=0x0; color.ui32[1]=0xFF; color.ui32[2]=0x0; color.ui32[3]=0x00;
	gifpacket_addgspacked(&gifpacket, color.ul128);
	
	vertex.ui32[0]=(-8)<<4; vertex.ui32[1]=(-12)<<4; vertex.ui32[2]=4; vertex.ui32[3]=1;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);
	
	color.ui32[0]=0x0; color.ui32[1]=0x0; color.ui32[2]=0xFF; color.ui32[3]=0x00;
	gifpacket_addgspacked(&gifpacket, color.ul128);
	
	vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(-6)<<4; vertex.ui32[2]=4; vertex.ui32[3]=1;
	gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x0; color.ui32[2]=0x0; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);
                                                       
        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(12)<<4; vertex.ui32[2]=4; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0x0; color.ui32[1]=0xFF; color.ui32[2]=0x0; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);                             

        vertex.ui32[0]=(8)<<4; vertex.ui32[1]=(-12)<<4; vertex.ui32[2]=4; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0x0; color.ui32[1]=0x0; color.ui32[2]=0xFF; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);                                                                         
                                                      
        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(-6)<<4; vertex.ui32[2]=4; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);                                   

	/* shot */
        prim=GS_SET_PRIM(GS_PRIM_POINT, GOURAUD(0), TEXTURED(0), FOG(0), ABE(0), AA(0), NA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(2), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0xFF; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=3; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0xFF; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(1)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=3; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* big asteroid */
	prim=GS_SET_PRIM(GS_PRIM_TRIFAN, GOURAUD(1), TEXTURED(0), FOG(0), ABE(0), AA(1), NA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(14), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        color.ui32[0]=0xC8; color.ui32[1]=0xC8; color.ui32[2]=0xC8; color.ui32[3]=0xFF;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=5; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        for (loop = 0; loop < 13; ++loop)
        {

                color.ui32[0]=0x18; color.ui32[1]=0x18; color.ui32[2]=0x18; color.ui32[3]=0x00;
                gifpacket_addgspacked(&gifpacket, color.ul128);

                vertex.ui32[0]=((int)(30 * cos(loop / 2.0f)))<<4; vertex.ui32[1]=((int)(30 * sin(loop / 2.0f)))<<4; vertex.ui32[2]=5; vertex.ui32[3]=1;
                gifpacket_addgspacked(&gifpacket, vertex.ul128);
        }

	/* med asteroid */
        prim=GS_SET_PRIM(GS_PRIM_TRIFAN, GOURAUD(1), TEXTURED(0), FOG(0), ABE(0), AA(1), NA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(14), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        color.ui32[0]=0xC8; color.ui32[1]=0xC8; color.ui32[2]=0xC8; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=5; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        for (loop = 0; loop < 13; ++loop)
        {

                color.ui32[0]=0x18; color.ui32[1]=0x18; color.ui32[2]=0x18; color.ui32[3]=0x00;
                gifpacket_addgspacked(&gifpacket, color.ul128);

                vertex.ui32[0]=((int)(18 * cos(loop / 2.0f)))<<4; vertex.ui32[1]=((int)(18 * sin(loop / 2.0f)))<<4; vertex.ui32[2]=5; vertex.ui32[3]=1;
                gifpacket_addgspacked(&gifpacket, vertex.ul128);
        }

        /* small asteroid */
        prim=GS_SET_PRIM(GS_PRIM_TRIFAN, GOURAUD(1), TEXTURED(0), FOG(0), ABE(0), AA(1), NA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(14), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);  

        color.ui32[0]=0xC8; color.ui32[1]=0xC8; color.ui32[2]=0xC8; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=5; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

	for (loop = 0; loop < 13; ++loop)
	{

	        color.ui32[0]=0x18; color.ui32[1]=0x18; color.ui32[2]=0x18; color.ui32[3]=0x00;
		gifpacket_addgspacked(&gifpacket, color.ul128);

		vertex.ui32[0]=((int)(8 * cos(loop / 2.0f)))<<4; vertex.ui32[1]=((int)(8 * sin(loop / 2.0f)))<<4; vertex.ui32[2]=5; vertex.ui32[3]=1;
		gifpacket_addgspacked(&gifpacket, vertex.ul128);
	}

        /* plasma unit */
        prim=GS_SET_PRIM(GS_PRIM_POINT, GOURAUD(0), TEXTURED(0), FOG(0), ABE(0), AA(0), NA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(8), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0xFF; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(1724)<<4; vertex.ui32[1]=(1934)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0xFF; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(1729)<<4; vertex.ui32[1]=(1936)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0xFF; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(1730)<<4; vertex.ui32[1]=(1936)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0xFF; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(1731)<<4; vertex.ui32[1]=(1936)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0xFF; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(1728)<<4; vertex.ui32[1]=(1937)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0xFF; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(1729)<<4; vertex.ui32[1]=(1937)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0xFF; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(1730)<<4; vertex.ui32[1]=(1937)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0xFF; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(1731)<<4; vertex.ui32[1]=(1937)<<4; vertex.ui32[2]=1; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* effect particle */
        prim=GS_SET_PRIM(GS_PRIM_POINT, GOURAUD(0), TEXTURED(0), FOG(0), ABE(1), AA(0), NA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(1), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        color.ui32[0]=0xD0; color.ui32[1]=0xD0; color.ui32[2]=0xD0; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=3; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* explosion sprites */
        prim=GS_SET_PRIM(GS_PRIM_TRIFAN, GOURAUD(0), TEXTURED(0), FOG(0), ABE(0), AA(1), NA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(18), EOP(0), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(-20)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-4)<<4; vertex.ui32[1]=(-9)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-14)<<4; vertex.ui32[1]=(-14)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-9)<<4; vertex.ui32[1]=(-4)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-20)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-9)<<4; vertex.ui32[1]=(4)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-14)<<4; vertex.ui32[1]=(14)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-4)<<4; vertex.ui32[1]=(9)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(20)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(4)<<4; vertex.ui32[1]=(9)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(14)<<4; vertex.ui32[1]=(14)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(9)<<4; vertex.ui32[1]=(4)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(20)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(9)<<4; vertex.ui32[1]=(-4)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(14)<<4; vertex.ui32[1]=(-14)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(4)<<4; vertex.ui32[1]=(-9)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0x00; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(-20)<<4; vertex.ui32[2]=6; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        prim=GS_SET_PRIM(GS_PRIM_TRIFAN, GOURAUD(0), TEXTURED(0), FOG(0), ABE(0), AA(1), NA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(18), EOP(1), PRE(1), prim, GIF_PACKED, NREG(2)));
        gifpacket_addgsdata(&gifpacket, 0x51);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(-10)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-2)<<4; vertex.ui32[1]=(-5)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-7)<<4; vertex.ui32[1]=(-7)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-5)<<4; vertex.ui32[1]=(-2)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-10)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-5)<<4; vertex.ui32[1]=(2)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-7)<<4; vertex.ui32[1]=(7)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(-2)<<4; vertex.ui32[1]=(5)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(10)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(2)<<4; vertex.ui32[1]=(5)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(7)<<4; vertex.ui32[1]=(7)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(5)<<4; vertex.ui32[1]=(2)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(10)<<4; vertex.ui32[1]=(0)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(5)<<4; vertex.ui32[1]=(-2)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(7)<<4; vertex.ui32[1]=(-7)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(2)<<4; vertex.ui32[1]=(-5)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

        color.ui32[0]=0xFF; color.ui32[1]=0xFF; color.ui32[2]=0x00; color.ui32[3]=0x00;
        gifpacket_addgspacked(&gifpacket, color.ul128);

        vertex.ui32[0]=(0)<<4; vertex.ui32[1]=(-10)<<4; vertex.ui32[2]=7; vertex.ui32[3]=1;
        gifpacket_addgspacked(&gifpacket, vertex.ul128);

	/* dummy giftag */
        prim=GS_SET_PRIM(GS_PRIM_POINT, GOURAUD(0), TEXTURED(0), FOG(0), ABE(0), AA(0), NA(0), CTXT(0), FIX(0));
        gifpacket_addgsdata(&gifpacket, GIF_SET_TAG(NLOOP(0), EOP(1), PRE(1), prim, GIF_PACKED, NREG(0)));
        gifpacket_addgsdata(&gifpacket, 0x51);

	gifpacket_terminate(&gifpacket);

	output=fopen(argv[1], "wb");
	
	if (output==NULL)
	{
		fprintf(stderr, "Could not open file \"%s\"\n", argv[1]);
		return -1;
	}

	fwrite(packet_data, sizeof(packet_data)/sizeof(qword_t), sizeof(qword_t), output);

	bytes=ftell(output);
	fclose(output);

	printf("Written %d bytes to \"%s\"\n", bytes, argv[1]);

	return 0;
}
