
#ifndef __PACKET_HIK_H__
#define __PACKET_HIK_H__

#include <sys/types.h>
#include "defines.h"

typedef struct
{
  u_int *current;
  u_long128 *base;
  u_long128 *dmatag;
  u_int *vifcodes;
  u_int len;
  u_long64 *giftag;
  u_int pad2;
  u_int pad3;
} vifpacket_t;

typedef struct
{
	u_int *current;
	u_long128 *base;
	u_long128 *dmatag;
	u_long64 *giftag;
} gifpacket_t;


void vifpacket_init(vifpacket_t *vpkt, u_long128 *buffer);
void vifpacket_reset(vifpacket_t *vpkt);
u_long128 *vifpacket_terminate(vifpacket_t *vpkt);
int  vifpacket_size(vifpacket_t *vpkt);

void vifpacket_cnt(vifpacket_t *vpkt, u_int flag);
void vifpacket_next(vifpacket_t *vpkt, u_long128 *next, u_int flag);
void vifpacket_end(vifpacket_t *vpkt, u_int flag);
void vifpacket_ref(vifpacket_t *vpkt, u_long128 *ref, u_int size, u_int opt1, u_int opt2, u_int flag);
void vifpacket_opendirectcode(vifpacket_t *vpkt, int stall);
void vifpacket_closedirectcode(vifpacket_t *vpkt);
void vifpacket_addcode(vifpacket_t *vpkt, u_int code);
void vifpacket_openupkcode(vifpacket_t *vpkt, u_short vuaddr, u_int upkcmd, u_int cl, u_int wl);
void vifpacket_closeupkcode(vifpacket_t *vpkt);

void vifpacket_adddata(vifpacket_t *vpkt, u_int data);
void vifpacket_addupkdata64( vifpacket_t *vpkt, u_long64 data );
void vifpacket_addupkdata64N(vifpacket_t *vpkt, u_long64* pData, u_int count);
void vifpacket_addupkdata128( vifpacket_t *vpkt, u_long128 data );
void vifpacket_addupkdata128N(vifpacket_t *vpkt, u_long128* pData, u_int count);

void vifpacket_dump(vifpacket_t *vpkt);


void gifpacket_init(gifpacket_t *gpkt, u_long128 *buffer);
void gifpacket_reset(gifpacket_t *gpkt);
u_long128 *gifpacket_terminate(gifpacket_t *gpkt);
int  gifpacket_size(gifpacket_t *gpkt);

void gifpacket_addgsdata(gifpacket_t *gpkt, u_long64 data);
void gifpacket_addgspacked(gifpacket_t *gpkt, u_long128 data);

void gifpacket_dump(gifpacket_t *gpkt);

inline static u_long128* align128(u_int* pPtr)
{
	while((u_int)pPtr & 0xc) *pPtr++ = 0;
	return (u_long128*)pPtr;
}

__inline__ static u_int CV2P(void* const pPtr){
	return (u_int)pPtr & 0x9fffffff;
}



#endif

