;
; Plasmaroids - VU1 demo
;
; Copyright 2003 Ben Tayler
; bjt@users.playstation2-linux.com
;

.init_vf_all
.init_vi_all

.syntax new

.vu
.include "vcl_sml.i"

PAD_square	.equ	H'7FFF	; 15 bit immediate limit
PAD_cross	.equ	H'4000
PAD_circle	.equ	H'2000
PAD_triangle	.equ	H'1000

PAD_start	.equ	H'0008
PAD_select	.equ	H'0001

PAD_R1		.equ	H'0800
PAD_R2		.equ	H'0200
PAD_L1		.equ	H'0400
PAD_L2		.equ	H'0100

PAD_left	.equ	H'0080
PAD_right	.equ	H'0020
PAD_up		.equ	H'0010
PAD_down	.equ	H'0040

partinfoaddr	.equ	200
maxpartinfoaddr	.equ	590	; maximum 130 particles on screen

setupflagaddr	.equ	590
fireflagaddr	.equ	591
plasmatimeraddr	.equ	592
plasmaflagaddr	.equ	593
parttimeraddr	.equ	594
randomseedaddr	.equ	595
hideflagaddr	.equ	596
spawntimeraddr	.equ	597
wavetimeraddr	.equ	598
astnumberaddr	.equ	599
padaddr		.equ	1023

shipposaddr	.equ	600
shipveladdr	.equ	601
shiprotaddr	.equ	602
shotinfoaddr	.equ	603
maxshotinfoaddr	.equ	615	; maximum 4 shots on screen
astinfoaddr	.equ	615
maxastinfoaddr	.equ	695	; maximum 15 asteroids on screen
plasmainfoaddr	.equ	695
explosioninfo	.equ	700
maxexplosion	.equ	722
banginfoaddr	.equ	750
maxbanginfoaddr	.equ	760	; max 5 bangs on screen

shipvertaddr	.equ	800
bigastvertaddr	.equ	806
medastvertaddr	.equ	820
smlastvertaddr	.equ	834
bangvertaddr	.equ	848
bang2vertaddr	.equ	866

shipprimaddr	.equ	0
shipstartaddr	.equ	2
shipmaxaddr	.equ	14	; 6 verts for ship

shotprimaddr	.equ	13
shotvertaddr	.equ	15	; 1 vert per shot

bigastprimaddr	.equ	18
bigaststartaddr	.equ	20
bigastmaxaddr	.equ	48	; 14 verts per asteroid

medastprimaddr	.equ	47
medaststartaddr	.equ	49
medastmaxaddr	.equ	77

smlastprimaddr	.equ	76
smlaststartaddr	.equ	78
smlastmaxaddr	.equ	106

plasmaprimaddr	.equ	105
plasmacoladdr	.equ	106
plasmavertaddr	.equ	107

partprimaddr	.equ	122
partcoladdr	.equ	123
partvertaddr	.equ	124

bangprimaddr	.equ	125
bangstartaddr	.equ	127
bangmaxaddr	.equ	163

bang2startaddr	.equ	164
bang2maxaddr	.equ	200

dummyprimaddr	.equ	199

maxshotframes	.equ	60
maxpartframes	.equ	80
maxparttimer	.equ	1
maxbangframes	.equ	15
maxspawntimer	.equ	120
maxwavetimer	.equ	180

--enter
--endenter

; ----------------------------------------------------------------------------
; initialise data memory
; ----------------------------------------------------------------------------

	; things to be done every frame

	iaddiu		pad, vi00, PAD_square	; zero pad
	iaddiu		pad, pad, 1		; get around 15bit limit

	iaddiu		pad, pad, PAD_cross
	ilw.x		hideflag, hideflagaddr(vi00)	; load shiphide flag

	ibne		hideflag, vi00, nocontrols	; branch if set
	ilw.w		pad, padaddr(vi00)	; read pad

nocontrols:

	ilw.x		setupflag, setupflagaddr(vi00)	; get setup flag
	ibgtz		setupflag, simulation	; branch if setup done

	; things to be done once only

	; read vertex info into vu data mem

	iaddiu		curraddr, vi00, shipstartaddr	; set start address
	iaddiu		maxaddr, vi00, shipmaxaddr	; set loop escape
	iaddiu		curraddr2, vi00, shipvertaddr	; set store address

	bal		temp, readvert	; store current pc and branch

	iaddiu		curraddr, vi00, bigaststartaddr
	iaddiu		maxaddr, vi00, bigastmaxaddr
	iaddiu		curraddr2, vi00, bigastvertaddr

	bal		temp, readvert

        iaddiu          curraddr, vi00, medaststartaddr
        iaddiu          maxaddr, vi00, medastmaxaddr   
        iaddiu          curraddr2, vi00, medastvertaddr

        bal             temp, readvert

        iaddiu          curraddr, vi00, smlaststartaddr                      
        iaddiu          maxaddr, vi00, smlastmaxaddr                         
        iaddiu          curraddr2, vi00, smlastvertaddr

        bal             temp, readvert

	iaddiu		curraddr, vi00, bangstartaddr
	iaddiu		maxaddr, vi00,	bangmaxaddr
	iaddiu		curraddr2, vi00, bangvertaddr

	bal		temp, readvert

	iaddiu		curraddr, vi00, bang2startaddr
	iaddiu		maxaddr, vi00, bang2maxaddr
	iaddiu		curraddr2, vi00, bang2vertaddr

	bal		temp, readvert

	b		storedone		; break out

readvert:

	VectorLoad	vert, 0, curraddr	; load ship vertex
	itof4.xy	vert, vert		; convert xy to float
	itof0.z		vert, vert		; convert z to float

	VectorSave	vert, 0, curraddr2	; store ship vertex
	iaddiu		curraddr2, curraddr2, 1	; increment store address

	iaddiu		curraddr, curraddr, 2	; next vertex
	ibne		curraddr, maxaddr, readvert	; loop

	jr		temp			; return

storedone:

	; read plasma information

	VectorLoad	vert, plasmavertaddr, vi00	; load plasma vertex
	itof4.xy	vert, vert		; convert to float
	VectorSave	vert, plasmainfoaddr, vi00	; save plasma vertex

	; set sine scale to 1.0

	iaddiu		curraddr, vi00, plasmainfoaddr	; load address
	max		temp, vf00, vf00[w]		; set to all ones
	VectorSave	temp, 4, curraddr		; save sine scale

	; set random seed

	loi		505.23245		; set initial seed
	add		temp, vf00, I

	rinit		r, temp[x]		; initialise generator
	rnext		temp, r			; get random number

	VectorSave	temp, randomseedaddr, vi00	; save seed

	; clear particle memory

	iaddiu		curraddr, vi00, partinfoaddr	; set start addr
	iaddiu		maxaddr, vi00, maxpartinfoaddr	; set loop escape

	mini		temp, vf00, vf00[x]	; get all zeros

clearaddr:

	VectorSave	temp, 0, curraddr	; save zeros

	iaddiu		curraddr, curraddr, 1	; increment loop counter
	ibne		curraddr, maxaddr, clearaddr	; escape

	; precalculate explosion velocity vectors

	loi		-10.0			; starting velocity

	add.xy		temp, vf00, I		; add velocity
	mul.y		temp2, temp, temp	; calculate radius squared

	iaddiu		curraddr, vi00, explosioninfo	; set start addr
	iaddiu		maxaddr, vi00, maxexplosion	; set loop escape

nextpart:

	add.y		temp, vf00, temp[x]	; move velocity to y

	mul.y		temp, temp, temp	; square
	sub.y		temp, temp2, temp	; subtract from radius squared

	sqrt		q, temp[y]		; calculate root
	add.y		temp, vf00, q		; set y velocity

	VectorSave	temp, 0, curraddr	; save velocity vector

	loi		-1.0
	mul.y		temp, temp, I		; mirror y coordinate

	VectorSave	temp, 1, curraddr	; save velocity vector

	loi		2.0
	add.x		temp, temp, I		; increment x velocity

	iaddiu		curraddr, curraddr, 2	; increment loop counter
	ibne		curraddr, maxaddr, nextpart	; branch if not done

	; set wavetimer to spawn at start

	iaddiu		temp, vi00, 2		; set timer
	isw.x		temp, wavetimeraddr(vi00)	; save timer

	; set starting asteroid number

	iaddiu		temp, vi00, 4		; set asteroid number
	isw.x		temp, astnumberaddr(vi00)	; save number

	; save setup flag

	iaddiu		setupflag, vi00, 1	; set setup as done
	isw.x		setupflag, setupflagaddr(vi00)	; store setup flag

simulation:

; ----------------------------------------------------------------------------
; initialise random number generator
; ----------------------------------------------------------------------------

	VectorLoad	temp, randomseedaddr, vi00	; load seed
	rinit		r, temp[x]		; initialise generator

	rnext		temp, r			; get random number
	VectorSave	temp, randomseedaddr, vi00	; save seed

; ----------------------------------------------------------------------------
; update particle timer
; ----------------------------------------------------------------------------

	ilw.x		parttimer, parttimeraddr(vi00)	; load timer
	ibeq		parttimer, vi00, timerzero	; branch if zero

	isubiu		parttimer, parttimer, 1	; decrement timer
	isw.x		parttimer, parttimeraddr(vi00)	; save timer

timerzero:

; ----------------------------------------------------------------------------
; update respawn timer
; ----------------------------------------------------------------------------

	ilw.x		temp, spawntimeraddr(vi00)	; load timer
	ibeq		temp, vi00, timerzero2		; branch if zero

	isubiu		temp, temp, 1		; decrement timer
	isw.x		temp, spawntimeraddr(vi00)	; save timer

timerzero2:

; ----------------------------------------------------------------------------
; update wave timer
; ----------------------------------------------------------------------------

	ilw.x		temp, wavetimeraddr(vi00)	; load timer
	ibeq		temp, vi00, timerzero3		; branch if zero

	isubiu		temp, temp, 1			; decrement timer
	isw.x		temp, wavetimeraddr(vi00)	; save timer

timerzero3:

; ----------------------------------------------------------------------------
; draw plasma background
; ----------------------------------------------------------------------------

	; set up plasma registers

	iaddiu		curraddr, vi00, plasmainfoaddr	; load info address

	VectorLoad	plasmavert, 0, curraddr	; load vert
	move		vert, plasmavert	; copy to vert

	VectorLoad	toadd, 1, curraddr	; load plasma variable
	loi		0.1e-1			; plasma cycle speed

	add.xz		toadd, toadd, I		; increment plasma variable
	VectorSave	toadd, 1, curraddr	; save plasma variable

	ilw.x		plasmaint, 2(curraddr)	; load hue integer
	iaddiu		plasmaint, plasmaint, 2	; increment hue integer

	VectorLoad	plasmahue, 3, curraddr	; load hue float

	loi		0.2e-2			; hue change
	add.x		plasmahue, plasmahue, I	; increment plasma hue

	isubiu		temp, plasmaint, 6000	; check for max hue
	ibltz		temp, nohuewrap		; branch if not at max hue

	iaddiu		plasmaint, vi00, 0	; zero plasma integer
	move.x		plasmahue, vf00		; zero plasma hue

nohuewrap:

	isw.x		plasmaint, 2(curraddr)	; save hue integer
	VectorSave	plasmahue, 3, curraddr	; save hue float

	; check plasma timer and update flags

	ilw.x		plasmaflags, plasmaflagaddr(vi00)	; load flags
	ilw.x		temp, plasmatimeraddr(vi00)	; load plasma timer

	isubiu		temp, temp, 1			; decrement timer
	ibgtz		temp, nottimerzero		; branch

	iaddiu		temp, vi00, 300			; reset timer

	isubiu		plasmaflags, plasmaflags, 1	; decrement flags
	ibgtz		plasmaflags, notflagszero	; branch

	iaddiu		plasmaflags, vi00, 15		; reset flags

notflagszero:

nottimerzero:

	isw.x		plasmaflags, plasmaflagaddr(vi00)	; save flags
	isw.x		temp, plasmatimeraddr(vi00)	; save plasma timer

	; update sine scales

	VectorLoad	plasmascale, 4, curraddr	; load sine scales
	loi		0.5e-2			; scale rate

	iaddiu		test, vi00, H'0001	; load test mask
	iand		test, test, plasmaflags	; check against flags

	ibeq		test, vi00, nosineone	; branch if flag not set
	add.x		plasmascale, plasmascale, I	; inc scale

	b		yessineone		; break out

nosineone:

	sub.x		plasmascale, plasmascale, I	; dec scale

yessineone:

	iaddiu		test, vi00, H'0002	; load test mask
	iand		test, test, plasmaflags	; check against flags

	ibeq		test, vi00, nosinetwo	; branch if flag not set
	add.y		plasmascale, plasmascale, I	; inc scale

	b		yessinetwo

nosinetwo:

	sub.y		plasmascale, plasmascale, I	; dec scale

yessinetwo:

	iaddiu		test, vi00, H'0004	; load test mask
	iand		test, test, plasmaflags	; check against flags

	ibeq		test, vi00, nosinethree ; branch if flag not set
	add.z		plasmascale, plasmascale, I	; inc scale

	b		yessinethree

nosinethree:

	sub.z		plasmascale, plasmascale, I	; dec scale

yessinethree:

	iaddiu		test, vi00, H'0008	; load test mask
	iand		test, test, plasmaflags	; check against flags

	ibeq		test, vi00, nosinefour	; branch if flag not set
	add.w		plasmascale, plasmascale, I	; inc scale

	b		yessinefour

nosinefour:

	sub.w		plasmascale, plasmascale, I	; dec scale

yessinefour:

	max		plasmascale, plasmascale, vf00[x]	; clamp to 0.0
	mini		plasmascale, plasmascale, vf00[w]	; clamp to 1.1

	VectorSave	plasmascale, 4, curraddr	; save sine scales

	; convert hsv to rgb

	move		plasmamod, vf00		; init plasma modifier

	isubiu		plasmaint, plasmaint, 1000
	ibgtz		plasmaint, notsector0	; branch if not sector 0

	; hue is in sector 0

	loi		1.0
	add.x		plasmamod, vf00, I	; put v in r field

	add.y		plasmamod, vf00, plasmahue[x]	; put t in g field

	b		foundhue		; break out

notsector0:

	isubiu		plasmaint, plasmaint, 1000
	ibgtz		plasmaint, notsector1	; branch if not sector 1

	; hue is in sector 1

	loi		1.0
	sub.x		plasmahue, plasmahue, I	; get fractional part

	loi		-1.0
	mul.x		plasmahue, plasmahue, I

	loi		1.0
	add.x		plasmahue, plasmahue, I

	add.x		plasmamod, vf00, plasmahue	; q in r field
	add.y		plasmamod, vf00, I	; v in g field

	b		foundhue		; break out

notsector1:

	isubiu		plasmaint, plasmaint, 1000
	ibgtz		plasmaint, notsector2	; branch if not sector 2

	; hue is in sector 2

	loi		2.0
	sub.x		plasmahue, plasmahue, I	; get fractional part

	loi		1.0
	add.y		plasmamod, vf00, I	; v in g field

	add.z		plasmamod, vf00, plasmahue[x]	; t in b field

	b		foundhue		; break out

notsector2:

	isubiu		plasmaint, plasmaint, 1000
	ibgtz		plasmaint, notsector3	; branch if not sector 3

	; hue is in sector 3

	loi		3.0
	sub.x		plasmahue, plasmahue, I	; get fractional part

	loi		-1.0
	mul.x		plasmahue, plasmahue, I

	loi		1.0
	add.x		plasmahue, plasmahue, I

	add.y		plasmamod, vf00, plasmahue[x]	; q in g field
	add.z		plasmamod, vf00, I	; v in b field

	b		foundhue		; break out

notsector3:

	isubiu		plasmaint, plasmaint, 1000
	ibgtz		plasmaint, notsector4	; branch if not sector 4

	; hue is in sector 4

	loi		4.0
	sub.x		plasmahue, plasmahue, I	; get fractional part

	add.x		plasmamod, vf00, plasmahue	; t in r field

	loi		1.0
	add.z		plasmamod, vf00, I	; v in b field

	b		foundhue		; break out

notsector4:

	; hue is in sector 5

	loi		5.0
	sub.x		plasmahue, plasmahue, I	; get fractional part

	loi		1.0
	add.x		plasmamod, vf00, I	; v in r field

	loi		-1.0
	mul.x		plasmahue, plasmahue, I

	loi		1.0
	add.x		plasmahue, plasmahue, I

	add.z		plasmamod, vf00, plasmahue[x]	; q in b field

foundhue:

	iaddiu		xloopcount, vi00, 0	; init x loop counter
	iaddiu		yloopcount, vi00, 0	; init y loop counter

	iaddiu		primaddr, vi00, plasmaprimaddr ; set primitive address

xloop:

	isubiu		temp, xloopcount, 640	; plasma width
	ibeq		temp, vi00, xloopdone	; branch if at max x

	loi		4.0			; x pixel interval
	add.x		vert, vert, I

	loi		0.1e-1			; x scale factor
	mul.xy		temp2, vert, I

	move		temp, vf00		; clear temp

	loi		4.0			; x variable
	mul.x		temp, temp2, I
	add.xz		temp, temp, toadd

	mul.z		temp, temp, I
	add.z		temp, temp, temp2[x]

	AngleSinCos	temp, temp		; calculate sines

	loi		50.0			; x variable
	mul.x		temp, temp, I
	mul.x		xanswer, temp, plasmascale	; scale and add x sine

	mul.z		temp, temp, I
	mul.z		temp, temp, plasmascale[y]	; scale x sine
	add.x		xanswer, xanswer, temp[z]	; add x sine

yloop:

	isubiu		temp, yloopcount, 224	; plasma height
	ibeq		temp, vi00, yloopdone	; branch if at max y

	loi		2.0			; y pixel interval
	add.y		vert, vert, I

	; write verts for plasma block

	iaddiu		curraddr, vi00, plasmavertaddr	; load address

	move		temp, vert		; copy vert
	move		out, vert		; init out register

	ftoi4.xy	out, temp		; convert to fixed
	VectorSave	out, 0, curraddr	; save plasma vert

	add.x		temp, temp, vf00[w]	; increment x coordinate
	ftoi4.xy	out, temp		; convert to fixed
	VectorSave	out, 2, curraddr	; write first vert

	add.x		temp, temp, vf00[w]
	ftoi4.xy	out, temp
	VectorSave	out, 4, curraddr

	add.x		temp, temp, vf00[w]
	ftoi4.xy	out, temp
	VectorSave	out, 6, curraddr

	add.y		temp, temp, vf00[w]	; increment y coordinate
	ftoi4.xy	out, temp
	VectorSave	out, 8, curraddr

	sub.x		temp, temp, vf00[w]	; decrement x coordinate
	ftoi4.xy	out, temp
	VectorSave	out, 10, curraddr

	sub.x		temp, temp, vf00[w]
	ftoi4.xy	out, temp
	VectorSave	out, 12, curraddr

	sub.x		temp, temp, vf00[w]
	ftoi4.xy	out, temp
	VectorSave	out, 14, curraddr	; write last vert

	loi		0.1e-1			; y scale factor
	mul.xy		temp2, vert, I

	loi		6.0			; y variable
	mul.y		temp, temp2, I
	add.x		temp, toadd, temp[y]

	mul.z		temp, toadd, I
	add.z		temp, temp, temp2[y]

	AngleSinCos	temp, temp		; calculate sines

	loi		75.0			; y variable
	mul.xz		temp, temp, I

	move.x		out, xanswer

	mul.x		temp, temp, plasmascale[z]	; scale y sine
	add.x		out, out, temp		; add y sine

	mul.z		temp, temp, plasmascale[w]	; scale y sine
	add.x		out, out, temp[z]	; add y sine

	abs		out, out		; make sure v is positive
	mul.xyz		out, plasmamod, out[x]	; multiply to get rgb

	ftoi0		out, out		; convert to fixed
	iaddiu		curraddr, vi00, plasmacoladdr	; load address

	VectorSave	out, 0, curraddr		; save vertex colours
	VectorSave	out, 2, curraddr
	VectorSave	out, 4, curraddr
	VectorSave	out, 6, curraddr
        VectorSave      out, 8, curraddr
        VectorSave      out, 10, curraddr
        VectorSave      out, 12, curraddr
        VectorSave      out, 14, curraddr

	xgkick		primaddr		; kick plasma unit

	iaddiu		yloopcount, yloopcount, 2	; inc y loop
	b		yloop			; loop

yloopdone:

	iaddiu		yloopcount, vi00, 0	; reset y loop
	move.y		vert, plasmavert	; reset y coord

	iaddiu		xloopcount, xloopcount, 4	; inc x loop
	b		xloop			; loop

xloopdone:

; ----------------------------------------------------------------------------
; perform ship simulation
; ----------------------------------------------------------------------------

	; update ship rotation

	VectorLoad	shiprot, shiprotaddr, vi00	; load ship rotation
	loi		0.8e-1			; rotation speed

	iaddiu		test, vi00, PAD_left
	iand		test, test, pad		; check for left rotation

	ibgtz		test, notleft		; branch if not left
	sub.x		shiprot, shiprot, I	; dec ship rotation

notleft:

	iaddiu		test, vi00, PAD_right
	iand		test, test, pad		; check for right rotation

	ibgtz		test, notright		; branch if not right
	add.x		shiprot, shiprot, I	; inc ship rotation

notright:

	VectorSave	shiprot, shiprotaddr, vi00	; save ship rotation
	VectorLoad	shippos, shipposaddr, vi00	; load ship pos

	; update ship velocity

	AngleSinCos	shiprot, trigtable	; calc trig table

	add.x		trigtable2, vf00, trigtable[y]
	add.y		trigtable2, vf00, trigtable[x]	; swap sin and cos

	VectorLoad	shipvel, shipveladdr, vi00	; load ship velocity
	add		acc, vf00, shipvel	; put ship velocity in acc

	iaddiu		test, vi00, PAD_cross	; load test bitmask
	iand		test, test, pad		; check against pad

	ibgtz		test, noaccel		; don't accel

	loi		0.1			; ship acceleration
	move		temp2, shipvel		; backup ship velocity

	msub.x		shipvel, trigtable, I	; update x shipvel
	madd.y		shipvel, trigtable, I	; update y shipvel

	; clamp ship velocity

	abs		temp, shipvel

	loi		9.0			; max ship velocity
	sub.xy		temp, temp, I

	iaddiu		test, vi00, H'0080
	fmand		test, test		; check for max x vel

	ibgtz		test, nomaxvelx		; branch if not at max
	move.x		shipvel, temp2

nomaxvelx:

	iaddiu		test, vi00, H'0040
	fmand		test, test		; check for max y vel

	ibgtz		test, nomaxvely		; branch if not at max
	move.y		shipvel, temp2

nomaxvely:

	; add exhaust particle

	ibgtz		parttimer, noaccel	; branch if more than zero
	iaddiu		partframes, vi00, maxpartframes	; set particle life

	move		partpos, shippos	; fill in particle position
	loi		5.0			; exhaust velocity

	move		partvel, shipvel	; fill in partvel fields
	add		acc, vf00, shipvel	; put shipvel in acc

	madd.x		partvel, trigtable, I
	msub.y		partvel, trigtable, I

	rget		random, r		; get random number

	loi		1.5
	sub		random, random, I	; normalise range

	loi		3.0
	mul		random, random, I	; scale random number

	mul.x		random, random, trigtable[y]
	mul.y		random, random, trigtable[x]	; scale with rotation

	add.xy		partvel, partvel, random	; add to velocity
	bal		calladdr, addpart	; add particle

	iaddiu		parttimer, vi00, maxparttimer	; set particle timer
	isw.x		parttimer, parttimeraddr(vi00)	; save timer

noaccel:

	VectorSave	shipvel, shipveladdr, vi00	; save ship velocity

	; update ship position

	VectorAdd	shippos, shippos, shipvel	; update ship pos

	; wrap at screen edges

	abs		temp, shippos

	loi		320.0			; max x coord
	sub.x		temp, temp, I

	iaddiu		test, vi00, H'0080

	fmand		test, test		; check for max x pos
	ibgtz		test, nowrapx		; branch if not at max

	loi		-0.996875		; try to avoid getting stuck
	mul.x		shippos, shippos, I	; wrap x pos

nowrapx:

	loi		224.0			; max y coord
	sub.y		temp, temp, I

	iaddiu		test, vi00, H'0040

	fmand		test, test		; check for max y pos
	ibgtz		test, nowrapy		; branch if not at max

	loi		-0.99553571		; try to avoid getting stuck
	mul.y		shippos, shippos, I	; wrap y pos

nowrapy:

	VectorSave	shippos, shipposaddr, vi00	; save ship pos

; ----------------------------------------------------------------------------
; update shot info and kick to gs
; ----------------------------------------------------------------------------

	; add shot if there are not too many onscreen

	iaddiu		test, vi00, PAD_square
	iaddiu		test, test, 1		; get around 15bit limit
	iand		test, test, pad		; check against pad

	ibne		test, vi00, nofirebutton	; if not pressed
	ilw.x		fireflag, fireflagaddr(vi00)	; load fire flag

	ibgtz		fireflag, noshot	; branch if flag set

	iaddiu		curraddr, vi00, shotinfoaddr	; set start address
	iaddiu		maxaddr, vi00, maxshotinfoaddr	; set loop escape

saveshot:

	ilw.x		shotframes, 0(curraddr)	; load shot frames
	ibgtz		shotframes, slotfull	; branch if slot full

	iaddiu		shotframes, vi00, maxshotframes	; set new shot life
	isw.x		shotframes, 0(curraddr)	; save shot life

	VectorSave	shippos, 1, curraddr	; save start shotpos
	loi		8.0			; shot muzzle velocity

	move		shotvel, shipvel	; fill in shotvel fields
	add		acc, vf00, shipvel	; put shipvel in acc

	msub.x		shotvel, trigtable, I
	madd.y		shotvel, trigtable, I

	VectorSave	shotvel, 2, curraddr	; save shotvel
	iaddiu		fireflag, vi00, 1	; set flag

	isw.x		fireflag, fireflagaddr(vi00)	; save flag
	b		shotsaved		; escape

slotfull:

	iaddiu		curraddr, curraddr, 3	; next shot slot
	ibne		curraddr, maxaddr, saveshot ; loop

nofirebutton:

	iaddiu		fireflag, vi00, 0	; unset flag
	isw.x		fireflag, fireflagaddr(vi00)	; save flag

shotsaved:

noshot:

	; update shot positions and lifespans, kick to gs

	iaddiu		curraddr, vi00, shotinfoaddr	; set start address
	iaddiu		maxaddr, vi00, maxshotinfoaddr	; set loop escape
	iaddiu		curraddr2, vi00, shotvertaddr	; set shot vert addr

updateshot:

	ilw.x		shotframes, 0(curraddr)		; load shot frames
	ibeq		shotframes, vi00, nextshotslot	; branch to next slot

	isubiu		shotframes, shotframes, 1	; dec shot frames
        isw.x		shotframes, 0(curraddr)	; save shot life

	VectorLoad	shotpos, 1, curraddr	; load shot position
	VectorLoad	shotvel, 2, curraddr	; load shot velocity

	VectorAdd	shotpos, shotpos, shotvel	; update shot pos
	VectorSave	shotpos, 1, curraddr	; save shot position

	VectorLoad	vert, shotvertaddr, vi00	; load shot vert
	itof0		vert, vert		; convert z to float

	move.xy		vert, shotpos		; fill in position

	loi		0.5
	mul.y		vert, vert, I		; halve height

	loi		2048.0
	add.xy		vert, vert, I		; translate to screen centre

	VertexFPtoGsXYZ2	out, vert	; convert to gs xyzw format
	VectorSave	out, 0, curraddr2	; save vertex

	add.x		vert, vert, vf00[w]	; increment x coordinate

	VertexFPtoGsXYZ2	out, vert	; convert
	VectorSave	out, 2, curraddr2	; save vertex

	iaddiu		primaddr, vi00, shotprimaddr
	xgkick		primaddr		; kick to gs

nextshotslot:

	iaddiu		curraddr, curraddr, 3	; next shot slot
	ibne		curraddr, maxaddr, updateshot	; loop

; ----------------------------------------------------------------------------
; update particles and kick to gs
; ----------------------------------------------------------------------------

	iaddiu		curraddr, vi00, partinfoaddr	; set start info addr
	iaddiu		maxaddr, vi00, maxpartinfoaddr	; set loop escape

updatepart:

	ilw.x		partframes, 0(curraddr)		; load particle frames
	ibeq		partframes, vi00, nextpartslot	; branch to next slot

	isubiu		partframes, partframes, 1	; dec particle frames
	isw.x		partframes, 0(curraddr)		; save particle life

	VectorLoad	partpos, 1, curraddr	; load particle position
	VectorLoad      partvel, 2, curraddr	; load particle velocity

	loi		0.90			; slowdown factor
	mul.xy		partvel, partvel, I	; scale velocity

	VectorSave	partvel, 2, curraddr	; save particle velocity

	VectorAdd	partpos, partpos, partvel	; update particle pos
	VectorSave	partpos, 1, curraddr	; save particle position

	VectorLoad	vert, partvertaddr, vi00	; load shot vert
	itof0		vert, vert		; convert z to float

	move.xy		vert, partpos		; fill in position

	loi		0.5
	mul.y		vert, vert, I		; halve height

	loi		2048.0
	add.xy		vert, vert, I		; translate to screen centre

	VertexFPtoGsXYZ2	vert, vert	; convert to gs xyzw format
	VectorSave	vert, partvertaddr, vi00	; save vertex
	isw.w		partframes, partcoladdr(vi00)	; save alpha info

	iaddiu		primaddr, vi00, partprimaddr
	xgkick		primaddr		; kick to gs

nextpartslot:

	iaddiu		curraddr, curraddr, 3	; next particle slot
	ibne		curraddr, maxaddr, updatepart	; loop

; ----------------------------------------------------------------------------
; update asteroid info and kick to gs
; ----------------------------------------------------------------------------

	; check for new wave

	ilw.x		wavetimer, wavetimeraddr(vi00)	; load timer
	ibgtz		wavetimer, skipcheck3	; skip if more than zero

	iaddiu		wavetimer, vi00, maxwavetimer	; set wave timer

	; update asteroid positions

	iaddiu		curraddr, vi00, astinfoaddr	; set start info addr
	iaddiu		maxaddr, vi00, maxastinfoaddr	; set loop escape

updateast:

	ilw.x		asttype, 0(curraddr)	; load asteroid type
	ibeq		asttype, vi00, nextastslot	; branch to next slot

	iaddiu		wavetimer, vi00, 0	; zero wave timer

	VectorLoad	astpos, 1, curraddr	; load asteroid position
	VectorLoad	astvel, 2, curraddr	; load asteroid velocity

	VectorAdd	astpos, astpos, astvel	; update asteroid position

	; wrap at screen edges

	abs		temp, astpos

	loi		320.0			; max x coord
	sub.x		temp, temp, I

	iaddiu		test, vi00, H'0080

	fmand		test, test		; check for max x pos
	ibgtz		test, noastwrapx	; branch if not at max

	loi		-0.996875		; try to avoid getting stuck
	mul.x		astpos, astpos, I	; wrap x pos

noastwrapx:

	loi		224.0			; max y coord
	sub.y		temp, temp, I

	iaddiu		test, vi00, H'0040

	fmand		test, test		; check for max y pos
	ibgtz		test, noastwrapy	; branch if not at max

	loi		-0.99553571		; try to avoid getting stuck
	mul.y           astpos, astpos, I	; wrap y pos

noastwrapy:

	VectorSave	astpos, 1, curraddr	; save asteroid position

	; update asteroid rotations

	VectorLoad	astrot, 3, curraddr	; load asteroid rotation
	VectorLoad	temp, 4, curraddr	; load rotation delta

	VectorAdd	astrot, astrot, temp	; update asteroid rot
	VectorSave	astrot, 3, curraddr	; save asteroid rotation

	AngleSinCos	astrot, asttrigtable	; calc asteroid trig table

	add.x		asttrigtable2, vf00, asttrigtable[y]
	add.y		asttrigtable2, vf00, asttrigtable[x]	; swap

	; assume asteroid is small

	iaddiu		curraddr2, vi00, smlaststartaddr	; set start
	iaddiu		maxaddr2, vi00, smlastmaxaddr	; set loop escape

	iaddiu		loadaddr, vi00, smlastvertaddr	; set load address
	iaddiu		primaddr, vi00, smlastprimaddr	; set prim address

	isubiu		asttype, asttype, 1	; dec asteroid type
	ibeq		asttype, vi00, storeast	; branch to update

	; assume asteroid is medium

	iaddiu		curraddr2, vi00, medaststartaddr
	iaddiu		maxaddr2, vi00, medastmaxaddr

	iaddiu		loadaddr, vi00, medastvertaddr
	iaddiu		primaddr, vi00, medastprimaddr

	isubiu		asttype, asttype, 1
	ibeq		asttype, vi00, storeast	; branch to update

	; asteroid is large

	iaddiu		curraddr2, vi00, bigaststartaddr
	iaddiu		maxaddr2, vi00, bigastmaxaddr

	iaddiu		loadaddr, vi00, bigastvertaddr
	iaddiu		primaddr, vi00, bigastprimaddr

storeast:

	VectorLoad	vert, 0, loadaddr	; load asteroid vert
	iaddiu		loadaddr, loadaddr, 1	; increment load address

	move		temp2, vert		; fill in out fields

        mul.xy          temp, vert, asttrigtable2
        sub.x           temp2, temp, temp[y]	; rotate x coord

        mul.xy          temp, vert, asttrigtable
        add.y           temp2, temp, temp[x]	; rotate y coord

	VectorAdd	temp2, temp2, astpos	; translate to ast pos

	loi		0.5
	mul.y		temp2, temp2, I		; halve height

	loi		2048.0
	add.xy		temp2, temp2, I		; translate to screen centre

	VertexFPtoGsXYZ2	temp2, temp2	; convert to gs xyzw format
	VectorSave	temp2, 0, curraddr2	; save vertex


	iaddiu		curraddr2, curraddr2, 2	; next vertex
	ibne		curraddr2, maxaddr2, storeast	; loop

	xgkick		primaddr		; kick asteroid to gs

	iaddiu		temp, vi00, dummyprimaddr	; set dummy prim
	xgkick		temp			; cause a stall

nextastslot:

	iaddiu		curraddr, curraddr, 5	; next asteroid slot
	ibne		curraddr, maxaddr, updateast	; loop

	isw.x		wavetimer, wavetimeraddr(vi00)	; save timer

skipcheck3:

; ----------------------------------------------------------------------------
; transform ship vertices
; ----------------------------------------------------------------------------

	; translate and rotate ship vertices

	iaddiu		curraddr, vi00, shipstartaddr	; set start address
	iaddiu		maxaddr, vi00, shipmaxaddr	; set loop escape
	iaddiu		curraddr2, vi00, shipvertaddr	; set load address

storeship:

	VectorLoad	vert, 0, curraddr2	; load ship vert
	iaddiu		curraddr2, curraddr2, 1	; increment load address

	move		temp2, vert		; fill in out fields

	mul.xy		temp, vert, trigtable2
	sub.x		temp2, temp, temp[y]	; rotate x coord

	mul.xy		temp, vert, trigtable
	add.y		temp2, temp, temp[x]	; rotate y coord

	VectorAdd	temp2, temp2, shippos	; translate to ship pos

        loi             0.5
        mul.y           temp2, temp2, I		; halve height

	loi		2048.0
	add.xy		temp2, temp2, I		; translate to screen centre

	VertexFPtoGsXYZ2	temp2, temp2	; convert to gs xyzw format
	VectorSave	temp2, 0, curraddr	; save vertex

	iaddiu		curraddr, curraddr, 2	; next vertex
	ibne		curraddr, maxaddr, storeship	; loop

; ----------------------------------------------------------------------------
; collision detection
; ----------------------------------------------------------------------------

	; loop through asteroids and check for collisions

	iaddiu		curraddr, vi00, astinfoaddr	; set start info addr
	iaddiu		maxaddr, vi00, maxastinfoaddr	; set loop escape

collision:

	ilw.x		asttype, 0(curraddr)	; load asteroid type
	ibeq		asttype, vi00, nextcollision	; branch to next slot

	VectorLoad	astpos, 1, curraddr	; load asteroid position

	; set asteroid collision radius

	loi		8.0			; small asteroid radius
	add.x		astradius, vf00, I	; set collision radius

	isubiu		asttype, asttype, 1	; dec asteroid type
	ibeq		asttype, vi00, foundtype	; branch if found

	loi		18.0			; med asteroid radius
	add.x		astradius, vf00, I

	isubiu		asttype, asttype, 1
	ibeq		asttype, vi00, foundtype

	loi		30.0			; big asteroid radius
	add.x		astradius, vf00, I

foundtype:

	; check for asteroid-shot collisions

	iaddiu		curraddr2, vi00, shotinfoaddr	; set start address
	iaddiu		maxaddr2, vi00, maxshotinfoaddr	; set loop escape

shotcollision:

	ilw.x		shotframes, 0(curraddr2)	; load shot frames
	ibeq		shotframes, vi00, nextshotcollision	; if empty

	VectorLoad	shotpos, 1, curraddr2	; load shot position
	VectorSub	temp, astpos, shotpos	; calculate distance

	mul.xy		temp, temp, temp	; x and y squared
	add.x		temp, temp, temp[y]	; add squares

	sqrt		q, temp[x]		; square root
	sub.x		temp, astradius, q	; sub asteroid radius

	iaddiu		test, vi00, H'0080	; load test bitmask
	fmand		test, test		; check for x collision

	ibne		test, vi00, nextshotcollision	; no collision branch

	; remove shot, downsize asteroid in a collision

	isw.x		vi00, 0(curraddr2)	; remove shot

	ilw.x		asttype, 0(curraddr)	; load asteroid type
	isubiu		asttype, asttype, 1	; downgrade asteroid
	isw.x		asttype, 0(curraddr)	; save asteroid type

	; add bang

	iaddiu		bangframes, vi00, maxbangframes	; set bang life
	move		bangpos, astpos		; set bang position

	bal		calladdr, addbang	; add bang

	; add explosion particles

	iaddiu		curraddr3, vi00, explosioninfo	; set start address
	iaddiu		maxaddr3, vi00, maxexplosion	; set loop escape

nextpart2:

	iaddiu		partframes, vi00, maxpartframes	; set particle life
	move		partpos, astpos		; set particle position

	VectorLoad	partvel, 0, curraddr3	; load velocity vector
	bal		calladdr, addpart	; add particle

	iaddiu		curraddr3, curraddr3, 1	; increment address
	ibne		curraddr3, maxaddr3, nextpart2	; loop if not done

nextshotcollision:

	iaddiu		curraddr2, curraddr2, 3	; next shot slot
	ibne		curraddr2, maxaddr2, shotcollision	; loop

	; check for asteroid-ship collisions

	ibne		hideflag, vi00, nextcollision	; skip if collided

	iaddiu		curraddr2, vi00, shipstartaddr	; set start address
	iaddiu		maxaddr2, vi00, shipmaxaddr	; set loop escape

shipcollision:

	VectorLoad	vert, 0, curraddr2	; load ship vertex
	itof4		vert, vert		; change to float

	loi		2048.0
	sub.xy		vert, vert, I		; translate from screen coords

	loi		2.0
	mul.y		vert, vert, I		; double y coordinate

	VectorSub	temp, astpos, vert	; calculate distance

	mul.xy		temp, temp, temp	; square
	add.x		temp, temp, temp[y]

	sqrt		q, temp[x]		; root
	sub.x		temp, astradius, q

	iaddiu		test, vi00, H'0080
	fmand		test, test

	ibne		test, vi00, nextshipcollision

	; set shiphide flag in a collision

	iaddiu		hideflag, vi00, 1	; set shiphide flag
	isw.x		hideflag, hideflagaddr(vi00)	; save shiphide flag

	; set respawn timer

	iaddiu		temp, vi00, maxspawntimer	; set timer
	isw.x		temp, spawntimeraddr(vi00)	; save timer

	; set ship position and velocity

	VectorSave	vf00, shipposaddr, vi00	; save ship position
	VectorSave	vf00, shipveladdr, vi00	; save ship velocity
	VectorSave	vf00, shiprotaddr, vi00	; save ship rotation

	; add bang

	iaddiu		bangframes, vi00, maxbangframes	; set bang life
	move		bangpos, shippos	; set bang position

	bal		calladdr, addbang	; add bang

	; add explosion particles

	iaddiu		curraddr3, vi00, explosioninfo	; set start address
	iaddiu		maxaddr3, vi00, maxexplosion	; set loop escape

nextpart3:

	iaddiu		partframes, vi00, maxpartframes	; set particle life
	move		partpos, shippos	; set particle position

	VectorLoad	partvel, 0, curraddr3	; load velocity vector
	bal		calladdr, addpart	; add particle

	iaddiu		curraddr3, curraddr3, 1	; increment address
	ibne		curraddr3, maxaddr3, nextpart3	; loop if not done

nextshipcollision:

	iaddiu		curraddr2, curraddr2, 2	; next ship vert
	ibne		curraddr2, maxaddr2, shipcollision	; loop

nextcollision:

	iaddiu		curraddr, curraddr, 5	; next asteroid slot
	ibne		curraddr, maxaddr, collision	; loop

skipcheck:

; ----------------------------------------------------------------------------
; kick ship to gs
; ----------------------------------------------------------------------------

	ibne		hideflag, vi00, hideship	; branch if flag set

	iaddiu		primaddr, vi00, shipprimaddr
	xgkick		primaddr		; display ship

hideship:

; ----------------------------------------------------------------------------
; update bangs and kick to gs
; ----------------------------------------------------------------------------

	iaddiu		curraddr, vi00, banginfoaddr	; set start info addr
	iaddiu		maxaddr, vi00, maxbanginfoaddr	; set loop escape

updatebang:

	ilw.x		bangframes, 0(curraddr)		; load bang frames
	ibeq		bangframes, vi00, nextbangslot	; branch to next slot

	isubiu		bangframes, bangframes, 1	; dec bang frames
	isw.x		bangframes, 0(curraddr)		; save bang life

	VectorLoad	bangpos, 1, curraddr	; load bang position

	iaddiu		curraddr2, vi00, bangstartaddr
	iaddiu		maxaddr2, vi00, bangmaxaddr

	iaddiu		loadaddr, vi00, bangvertaddr

storebang:

	VectorLoad	vert, 0, loadaddr	; load bang vert

	move		temp2, vert		; fill in out fields
	VectorAdd	temp2, temp2, bangpos	; translate to bang pos

	loi		0.5
	mul.y		temp2, temp2, I		; halve height

	loi		2048.0
	add.xy		temp2, temp2, I		; translate to screen centre

	VertexFPtoGsXYZ2	temp2, temp2	; convert to gs xyzw format
	VectorSave	temp2, 0, curraddr2	; save vertex

	VectorLoad	vert, 18, loadaddr	; load bang2 vert

	move		temp2, vert		; fill in out fields
	VectorAdd	temp2, temp2, bangpos	; translate to bang pos

	loi		0.5
	mul.y		temp2, temp2, I		; halve height

	loi		2048.0
	add.xy		temp2, temp2, I		; translate to screen centre

	VertexFPtoGsXYZ2	temp2, temp2	; convert to gs xyzw format
	VectorSave	temp2, 37, curraddr2	; save vertex

	iaddiu		loadaddr, loadaddr, 1	; increment load address
	iaddiu		curraddr2, curraddr2, 2	; next vertex

	ibne		curraddr2, maxaddr2, storebang	; loop

	iaddiu		primaddr, vi00, bangprimaddr
	xgkick		primaddr		; kick to gs

	iaddiu		temp, vi00, dummyprimaddr	; set dummy prim
	xgkick		temp		; cause a stall

nextbangslot:

	iaddiu		curraddr, curraddr, 2	; next bang slot
	ibne		curraddr, maxaddr, updatebang	; loop

; ----------------------------------------------------------------------------
; check for respawn
; ----------------------------------------------------------------------------

	ibeq		hideflag, vi00, skipcheck2	; skip if not hidden
	ilw.x		temp, spawntimeraddr(vi00)	; load timer

	ibne		temp, vi00, skipcheck2		; skip if not zero
	iaddiu		hideflag, vi00, 0	; unset shiphide flag

	iaddiu		curraddr, vi00, astinfoaddr	; set start address
	iaddiu		maxaddr, vi00, maxastinfoaddr	; set loop escape

astslot:

	ilw.x		asttype, 0(curraddr)	; load asteroid type
	ibeq		asttype, vi00, nextastslot2	; branch to next slot

	VectorLoad	astpos, 1, curraddr	; load asteroid position
	abs		temp, astpos

	loi		100.0			; bounding box width
	sub.x		temp, temp, I

	iaddiu		test, vi00, H'0080
	fmand		test, test		; check if inside box

	ibeq		test, vi00, nextastslot2	; branch if not inside

	loi		100.0			; bounding box height
	sub.y		temp, temp, I

	iaddiu		test, vi00, H'0040
	fmand		test, test		; check if inside box

	ibeq		test, vi00, nextastslot2	; branch if not inside
	iaddiu		hideflag, vi00, 1	; set shiphide flag

nextastslot2:

	iaddiu		curraddr, curraddr, 5	; next asteroid slot
	ibne		curraddr, maxaddr, astslot	; branch if not done

	isw.x		hideflag, hideflagaddr(vi00)	; save shiphide flag

skipcheck2:

; ----------------------------------------------------------------------------
; create new asteroid wave
; ----------------------------------------------------------------------------

	iaddiu		temp, vi00, 1		; set test integer
	ibne		wavetimer, temp, skipcheck4	; skip if not equal

	; add more asteroids

	iaddiu		curraddr, vi00, astinfoaddr	; set start
	ilw.x		temp2, astnumberaddr(vi00)	; load asteroid number

spawnast:

	iaddiu		temp, vi00, 3
	isw.x		temp, 0(curraddr)	; save big asteroid type

	rnext.x		random, r		; get random number
	rnext.y		random, r		; get random number

	loi		1.5
	sub.xy		random, random, I	; normalise range

	loi		2.0
	mul.xy		random, random, I	; scale to 1.0

	loi		320.0			; max x position
	mul.x		temp, random, I

	loi		224.0			; max y position
	mul.y		temp, random, I

	VectorSave	temp, 1, curraddr	; save asteroid position

	rnext.x		random, r
	rnext.y		random, r

	loi		1.5
	sub.xy		random, random, I	; normalise range

	loi		2.0
	mul.xy		random, random, I	; scale to 1.0

	loi		3.0
	mul.xy		temp, random, I		; max velocity

	VectorSave	temp, 2, curraddr	; saver asteroid velocity

	rnext.x		random, r		; get random number

	loi		1.5
	sub.x		random, random, I	; normalise range

	loi		2.0
	mul.x		random, random, I	; scale to 1.0

	loi		0.3
	mul.x		temp, random, I		; max rotational speed

	VectorSave	temp, 4, curraddr	; save rotational speed
	iaddiu		curraddr, curraddr, 5	; next asteroid slot

	isubiu		temp2, temp2, 1		; decrement asteroid number
	ibgtz		temp2, spawnast		; branch if not done

	ilw.x		temp2, astnumberaddr(vi00)	; load asteroid number
	loi		15.0			; asteroid limit

	iaddiu		temp, vi00, I
	ibeq		temp2, temp, skipcheck4	; branch if at limit

	iaddiu		temp2, temp2, 1		; increment asteroid number
	isw.x		temp2, astnumberaddr(vi00)	; save asteroid number

skipcheck4:

	b		endfunctions		; branch to end

; ----------------------------------------------------------------------------
; function: add a particle
; ----------------------------------------------------------------------------

addpart:

	iaddiu		curraddr4, vi00, partinfoaddr	; set start address
	iaddiu		maxaddr4, vi00, maxpartinfoaddr	; set loop escape

savepart:

	ilw.x		temp3, 0(curraddr4)	; load particle frames
	ibgtz		temp3, partslotfull	; branch if slot full

	isw.x		partframes, 0(curraddr4)	; save particle life
	VectorSave	partpos, 1, curraddr4	; save start particle pos

	VectorSave	partvel, 2, curraddr4	; save particle velocity
	b		partsaved		; escape

partslotfull:

	iaddiu		curraddr4, curraddr4, 3	; next particle slot
	ibne		curraddr4, maxaddr4, savepart	; loop

partsaved:

	jr		calladdr		; return

; ----------------------------------------------------------------------------
; function: add a bang
; ----------------------------------------------------------------------------

addbang:

	iaddiu		curraddr4, vi00, banginfoaddr	; set start address
	iaddiu		maxaddr4, vi00, maxbanginfoaddr	; set loop escape

savebang:

	ilw.x		temp3, 0(curraddr4)	; load bang frames
	ibgtz		temp3, bangslotfull	; branch if slot full

	isw.x		bangframes, 0(curraddr4)	; save bang life
	VectorSave	bangpos, 1, curraddr4	; save bang position

	b		bangsaved		; escape

bangslotfull:

	iaddiu		curraddr4, curraddr4, 2	; next bang slot
	ibne		curraddr4, maxaddr4, savebang	; loop

bangsaved:

	jr		calladdr		; return

; ----------------------------------------------------------------------------
; end of functions
; ----------------------------------------------------------------------------

endfunctions:

--exit
--endexit

.end
