require "../shared/vulib"

# a null giftag
GifPacket.build

VuData.addLabel("status")
VuData.add(0.chr * 16) # status word

# a packet to display the generated textures
VuData.addLabel("displaytextures")

# initpacket for the texture generator
VuData.addLabel("texgeninitpacket")
GifPacket.build do |gp|
	gp.addTest(1, 0, 0, 1, 0, 0, 1, ZALWAYS)
	gp.addXyoffset(0, 0)
	gp.addTex1(1, 0, LINEAR, LINEAR, 1, 0, 0)
	gp.addClamp(0, 0)
end

# build a packet to set tex0 to one of the buffers
VuData.addLabel("buftex0packet")
GifPacket.build(nil, 1, 1, [0xe])
t0 = (2 << 14) + (7 << 26) + (7 << 30) + (1 << 34)
l = t0 & (2**32 - 1) # factor for tbp is -2^34
h = t0 >> 32
VuData.add(l)
VuData.add(h)
VuData.add(6)
VuData.add(0)

# a packet to set frame to one of the buffers
VuData.addLabel("bufframepacket")
GifPacket.build {|gp| gp.addFrame(0, 2, 0)}

# a point giftag
VuData.addLabel("pointgiftag")
GifPacket.build(PRIM_POINT, -1, -1, [1, 5])

# a sprite giftag
VuData.addLabel("spritegiftag")
GifPacket.build(PRIM_SPRITE | PRIM_TEXTURE | PRIM_UV | PRIM_ALPHA, -1, -1,
	[3, 5, 3, 5])

# a tristrip giftag
VuData.addLabel("tristripgiftag")
GifPacket.build(PRIM_TRIANGLESTRIP | PRIM_TEXTURE | PRIM_UV | PRIM_ALPHA, -1, -1,
	[3, 5, 3, 5, 3, 5, 3, 5])

# a solid sprite
VuData.addLabel("solidsprite")
GifPacket.build(PRIM_SPRITE | PRIM_ALPHA) do |gp|
	gp.addXyz2(0, 0, 0)
	gp.addXyz2(128, 128, 0)
end

# A+D giftag
VuData.addLabel("ADtag")
GifPacket.build(nil, -1, -1, [0xe])

# color giftag
VuData.addLabel("colortag")
GifPacket.build(nil, -1, -1, [1])

# a frame reg for the palette
VuData.addLabel("palframe")
GifPacket.build do |gp|
	gp.addFrame(511, 1, 0)
end

# a paletted tex0
VuData.addLabel("bufpaltex0packet")
GifPacket.build(nil, 1, 1, [0xe])
t0 = (4 << 14) + (PSMT8 << 20) + (8 << 26) + (8 << 30) + (1 << 34) +
	((511*32) << 37) + (1 << 61)
l = t0 & (2**32 - 1) # factor for tbp is 2^-84
h = t0 >> 32
VuData.add(l)
VuData.add(h)
VuData.add(6)
VuData.add(0)

# channel masks
VuData.addLabel("channelmasks")
4.times {|i| VuData.add(~(255 << (i*8)))}

# testsprite
VuData.addLabel("testsprite")
GifPacket.build(PRIM_SPRITE | PRIM_TEXTURE | PRIM_UV) do |gp|
	gp.addRgbaq(128, 128, 128, 128)
	gp.addUv(0, 0)
	gp.addXyz2(2048 - 320, 2048 - 112, 0xffffff)
	gp.addUv(320, 224)
	gp.addXyz2(2048 + 320, 2048 + 112, 0xffffff)
end

# init packet for the main demo
VuData.addLabel("geoinit")
GifPacket.build do |gp|
	gp.addTest(0, 0, 0, 0, 0, 0, 1, 2)
	gp.addXyoffset(2048 - 320, 2048 - 112)
	gp.addClamp(0, 0)
end

# init packet for afterefects
VuData.addLabel("fxinit")
GifPacket.build do |gp|
	gp.addClamp(2, 2, 0, 640-1, 0, 224-1)
end

# another tristrip tag, this time with st mapping
VuData.addLabel("geotag")
GifPacket.build(PRIM_TRIANGLESTRIP | PRIM_TEXTURE | PRIM_GOURAUD, -1, -1, [2, 1, 5])

# clipvector
near = 0.1
far = 50.0
VuData.addLabel("clipvector")
VuData.add(1.0 / 2000.0)
VuData.add(1.0 / 2000.0)
VuData.add((near + far) / (near - far))
VuData.add(2.0 * near * far / (near + far))

# alpha functions
VuData.addLabel("alphafunctions")
VuData.add(0b01000100); VuData.add(0); VuData.add(0x42); VuData.add(0)		# standard source alpha blending
VuData.add(0b01100100); VuData.add(64); VuData.add(0x42); VuData.add(128)	# fixed 50% alpha blend
VuData.add(0b01101000); VuData.add(128); VuData.add(0x42); VuData.add(128)	# fixed 87% alpha blend
VuData.add(0b01100100); VuData.add(128); VuData.add(0x42); VuData.add(128)	# no alpha blend
VuData.add(0b00100110); VuData.add(128); VuData.add(0x42); VuData.add(128)	# sub
VuData.add(0b01101000); VuData.add(128); VuData.add(0x42); VuData.add(128)	# add
VuData.add(0b00101001); VuData.add(90); VuData.add(0x42); VuData.add(90)	# glare gain blur
VuData.add(0b01100100); VuData.add(112); VuData.add(0x42); VuData.add(128)	# fixed 50% alpha blend
VuData.add(0b00101001); VuData.add(67); VuData.add(0x42); VuData.add(67)	# glare gain blur

# tex0 packets (setting the frame/back/z-buffer as a texture)
VuData.addLabel("tex0packets")
GifPacket.build {|gp| gp.addTex0(0, 10, 0, 10, 8, 0, 0)}
GifPacket.build {|gp| gp.addTex0(0x46 * 32, 10, 0, 10, 8, 0, 0)}
GifPacket.build {|gp| gp.addTex0(0x46 * 64, 10, 0, 10, 8, 0, 0)}

# frame packets
VuData.addLabel("framepackets")
GifPacket.build {|gp| gp.addFrame(0x46 * 0, 10, 0)}
GifPacket.build {|gp| gp.addFrame(0x46 * 1, 10, 0)}
GifPacket.build {|gp| gp.addFrame(0x46 * 2, 10, 0)}

# a sprite giftag (using stq coordinates)
VuData.addLabel("spritestqgiftag")
GifPacket.build(PRIM_SPRITE | PRIM_TEXTURE | PRIM_ALPHA, -1, -1,
	[2, 5, 2, 5])

# cube mesh
VuData.addLabel("cubeverts")
VuData.add(Vector(-0.5, -0.5, -0.5))
VuData.add(Vector(0.5, -0.5, -0.5))
VuData.add(Vector(-0.5, 0.5, -0.5))
VuData.add(Vector(0.5, 0.5, -0.5))
VuData.add(Vector(0.5, 0.5, -0.5))
VuData.add(Vector(-0.5, 0.5, -0.5))
VuData.add(Vector(0.5, 0.5, 0.5))
VuData.add(Vector(-0.5, 0.5, 0.5))
VuData.add(Vector(-0.5, 0.5, 0.5))
VuData.add(Vector(-0.5, 0.5, -0.5))
VuData.add(Vector(-0.5, -0.5, 0.5))
VuData.add(Vector(-0.5, -0.5, -0.5))

VuData.addLabel("cubenormals")
VuData.add(Vector(0, 0, -1))
VuData.add(Vector(0, 1, 0))
VuData.add(Vector(-1, 0, 0))

# light
VuData.addLabel("lights")
VuData.addLightMatrix(
	Vector.new(0, 1, -1),
	Vector.new(-1, 0.5, 1),
	Vector.new(1, 0, 1),
	Vector.new(0, -1, 0))
VuData.add(Vector.new(192, 192, 160))
VuData.add(Vector.new(48, 48, 64))
VuData.add(Vector.new(48, 56, 48))
VuData.add(Vector.new(32, 24, 24))

VuData.addLabel("timeval")
VuData.add(3.0)
VuData.align

VuData.addLabel("blitoffset")
VuData.add(Vector(0.5, 0.5))

VuData.addLabel("texturedata")
File.open("../texgen/texture.bin", "rb") {|f| VuData.add(f.read)}

VuData.addLabel("geometriedata")
File.open("geometrie.dat", "rb") {|f| VuData.add(f.read)}

# splines
VuData.addLabel("splines")
File.open("spline.dat", "rb") {|f| VuData.add(f.read)}
VuData.addLabel("splineptr")
VuData.add(VuData.getLabel("splineptr") - 13)
VuData.align

# just declarations after this

VuData.addLabel("meshbuffer")
VuData.add(0.chr * 16 * 3 * 22) # space for a tristrip of 10 quads

VuData.addLabel("outputbuffers")
VuData.add(0.chr * 16 * 3 * 22 * 2)

VuData.addLabel("matrixstack")
VuData.add(0.chr * 16 * 4 * 8)

VuData.addLabel("loopstack")
VuData.add(0.chr * 16 * 2 * 12)

VuData.addLabel("cameramatrix")
VuData.add(Vector.new(1, 0, 0))
VuData.add(Vector.new(0, -1, 0))
VuData.add(Vector.new(0, 0, 1))
VuData.add(Vector.new(0, 0.3, -1))
VuData.add(Vector.new(0))			# euler rotation

VuData.addLabel("keys")
VuData.add(0.chr * 16)

VuData.addLabel("free_mem")

VuData.setSize(VuData.getLabel("meshbuffer"))

VuData.write
