# read labels

labels = {}
File.foreach("geolabels.txt") do |line|
	l, a = line.split
	labels[l] = a.to_i
end

def nextline(f)
	line = ""
	while line == ""
		line = f.readline
		line.gsub!(/\#.*/, '')
		line.strip!
	end
	return line
end

def scanv(v)
	v = v.split(',')
	return [v[0].to_f, v[1].to_f, v[2].to_f].pack('f3')
end

File.open(ARGV[0]) do |f|
	File.open(ARGV[1], "wb") do |o|
		until f.eof?
			lab = nextline(f).split(',')
			a = labels[lab[0].strip]
			raise "Unknown label" unless a
			pos = ""
			at = ""
			4.times do |i|
				l = nextline(f).squeeze("\t").split("\t")
				if i == 0
					w = [a].pack('L')
				elsif lab.size == 1
					w = [-1].pack('L')
				else
					w = [lab[1].to_f].pack('f')
				end
				pos += scanv(l[0]) + w
				at += scanv(l[1]) + 0.chr*4
			end
			[pos, at].each do |s|
				o.print s[0, 16], s, s[48, 16]
			end
		end
		o.print 255.chr * 16
	end
end
