require "../shared/vulib"

# a null giftag
GifPacket.build

VuData.addLabel("status")
VuData.add(0.chr * 16) # status word

# a packet to display the generated textures
VuData.addLabel("displaytextures")
GifPacket.build(PRIM_SPRITE | PRIM_TEXTURE | PRIM_UV) do |gp|
	16.times do |i|
		gp.addTex0((35 + i) * 256, 2, PSMCT32, 7, 7, 0, DECAL)
		gp.addUv(0.5, 0.5)
		gp.addXyz2((i % 4) * 256, (i / 4) * 128, 0)
		gp.addUv(128.5, 128.5)
		gp.addXyz2((i % 4) * 256 + 256, (i / 4) * 128 + 128, 0)
	end
end

# initpacket for the texture generator
VuData.addLabel("texgeninitpacket")
GifPacket.build do |gp|
	gp.addTest(0, 0, 0, 0, 0, 0, 1, ZALWAYS)
	gp.addXyoffset(0, 0)
	gp.addTex1(1, 0, LINEAR, LINEAR, 1, 0, 0)
end

# build a packet to set tex0 to one of the buffers
VuData.addLabel("buftex0packet")
GifPacket.build(nil, 1, 1, [0xe])
t0 = (2 << 14) + (7 << 26) + (7 << 30) + (1 << 34)
l = t0 & (2**32 - 1) # factor for tbp is -2^34
h = t0 >> 32
VuData.add(l)
VuData.add(h)
VuData.add(6)
VuData.add(0)

# a packet to set frame to one of the buffers
VuData.addLabel("bufframepacket")
GifPacket.build {|gp| gp.addFrame(0, 2, 0)}

# a point giftag
VuData.addLabel("pointgiftag")
GifPacket.build(PRIM_POINT, -1, -1, [1, 5])

# a sprite giftag
VuData.addLabel("spritegiftag")
GifPacket.build(PRIM_SPRITE | PRIM_TEXTURE | PRIM_UV | PRIM_ALPHA, -1, -1,
	[3, 5, 3, 5])

# a trilist giftag
VuData.addLabel("tristripgiftag")
GifPacket.build(PRIM_TRIANGLESTRIP | PRIM_TEXTURE | PRIM_UV | PRIM_ALPHA, -1, -1,
	[3, 5, 3, 5, 3, 5, 3, 5])

# a solid sprite
VuData.addLabel("solidsprite")
GifPacket.build(PRIM_SPRITE | PRIM_ALPHA) do |gp|
	gp.addXyz2(0, 0, 0)
	gp.addXyz2(128, 128, 0)
end

# A+D giftag
VuData.addLabel("ADtag")
GifPacket.build(nil, -1, -1, [0xe])

# color giftag
VuData.addLabel("colortag")
GifPacket.build(nil, -1, -1, [1])

# a frame reg for the palette
VuData.addLabel("palframe")
GifPacket.build do |gp|
	gp.addFrame(511, 1, 0)
end

# a paletted tex0
VuData.addLabel("bufpaltex0packet")
GifPacket.build(nil, 1, 1, [0xe])
t0 = (4 << 14) + (PSMT8 << 20) + (8 << 26) + (8 << 30) + (1 << 34) +
	((511*32) << 37) + (1 << 61)
l = t0 & (2**32 - 1) # factor for tbp is 2^-84
h = t0 >> 32
VuData.add(l)
VuData.add(h)
VuData.add(6)
VuData.add(0)

# channel masks
VuData.addLabel("channelmasks")
4.times {|i| VuData.add(~(255 << (i*8)))}

VuData.addLabel("texturedata")
File.open("texture.bin", "rb") {|f| VuData.add(f.read)}

VuData.addLabel("free_mem")

VuData.write
