.syntax new

FIXEDALPHA	.equ	100	; 0b01100100
ADDALPHA	.equ	41	; 0b00101001
SUBALPHA	.equ	38	; 0b00100110
SRCSUBALPHA	.equ	98	; 0b01100010
MULALPHA	.equ	137	; 0b10001001

SELECT		.equ	H'1
START		.equ	H'8
UP			.equ	H'10
RIGHT		.equ	H'20
DOWN		.equ	H'40
LEFT		.equ	H'80
L2			.equ	H'100
R2			.equ	H'200
L1			.equ	H'400
R1			.equ	H'800
TRIANGLE	.equ	H'1000
CIRCLE		.equ	H'2000
CROSS		.equ	H'4000
SQUARE		.equ	H'8000
	
--enter
	.init_vi_all
	.init_vf_all
--endenter

.raw
	nop fsset 0								; making vcl happy
.endraw

	ilw.x		stage, status(vi0)		; get current stage
	ibeq		stage, vi0, texgen	; texturegeneration stage

	; display stage

	ilw.w		pad, 0x3ff(vi0)
	ilw.x		pos, texgeninitpacket+2(vi0)
	iaddiu		mask, vi0, LEFT
	iand		tmp, pad, mask
	ibne		tmp, vi0, notleft
	isubiu		pos, pos, 128
	ibltz		pos, xneg
notleft:
	iaddiu		mask, vi0, RIGHT
	iand		tmp, pad, mask
	ibne		tmp, vi0, notright
	iaddiu		pos, pos, 128
notright:
	isw.x		pos, texgeninitpacket+2(vi0)
xneg:
	ilw.y		pos, texgeninitpacket+2(vi0)
	iaddiu		mask, vi0, UP
	iand		tmp, pad, mask
	ibne		tmp, vi0, notup
	isubiu		pos, pos, 64
	ibltz		pos, yneg
notup:
	iaddiu		mask, vi0, DOWN
	iand		tmp, pad, mask
	ibne		tmp, vi0, notdown
	iaddiu		pos, pos, 64
notdown:
	isw.y		pos, texgeninitpacket+2(vi0)
yneg:

	iaddiu		packet, vi0, texgeninitpacket
	xgkick		packet
	iaddiu		packet, vi0, displaytextures
	xgkick		packet
--cont

texgen:
	iaddiu		packet, vi0, texgeninitpacket	; init some gs registers
	xgkick		packet
	
; ** generate a greyscale palette
	iaddiu		packet, vi0, palframe
	xgkick		packet
	iaddiu		packet, vi0, free_mem
	lq			giftag, pointgiftag(vi0)
	sq			giftag, 0(packet)
	iaddiu		mask231, vi0, 231
	iaddiu		mask8, vi0, 8
	iaddiu		mask16, vi0, 16
	iaddiu		endcnt, vi0, 16
	sub			pos, vf0, vf0
	iaddiu		ycnt, vi0, 0
palyloop:
	iaddiu		xcnt, vi0, 0
palxloop:
	iadd		col, ycnt, ycnt
	iadd		col, col, col
	iadd		col, col, col
	iadd		col, col, col
	iadd		col, col, xcnt
	iand		col8, col, mask8
	iand		col16, col, mask16
	iand		col, col, mask231
	iadd		col8, col8, col8
	iadd		col, col, col8
	iaddiu		col, col, 8
	ibne		col16, vi0, palbitset
	isubiu		col, col, 8
palbitset:
	mfir		col, col
	xgkick		vi0
	sq			col, 1(packet)
	ftoi4		ipos, pos
	sq			ipos, 2(packet)
	xgkick		packet
	add.x		pos, pos, vf0[w]
	iaddiu		xcnt, xcnt, 1
	ibne		xcnt, endcnt, palxloop
	loi			16
	sub.x		pos, pos, i
	add.y		pos, pos, vf0[w]
	iaddiu		ycnt, ycnt, 1
	ibne		ycnt, endcnt, palyloop
; ***

	loi			0X6842b28a
	add.x		seed, vf0, i
	rinit		r, seed[x]						; init the rnd generator
	iaddiu		scriptptr, vi0, texturedata		; load pointer to the texture script

texgen_loop:
	ilw.x		op, 0(scriptptr)				; get next op
	iaddiu		scriptptr, scriptptr, 1			; increment pointer
	ibltz		op, texgen_end					; a negative op marks the end

	isubiu		op2, op, 1
	ibeq		op, vi0, texgen_noise			; op 0 = noise
	isubiu		op, op2, 1
	ibeq		op2, vi0, texgen_blur			; op 1 = blur
	isubiu		op2, op, 1
	ibeq		op, vi0, texgen_emboss			; op 2 = emboss
	isubiu		op, op2, 1
	ibeq		op2, vi0, texgen_adjust			; op 3 = adjust
	isubiu		op2, op, 1
	ibeq		op, vi0, texgen_add				; op 4 = add
	isubiu		op, op2, 1
	ibeq		op2, vi0, texgen_grey			; op 5 = grey
	isubiu		op2, op, 1
	ibeq		op, vi0, texgen_mul				; op 6 = mul
	isubiu		op, op2, 1
	ibeq		op2, vi0, texgen_invert			; op 7 = invert
	isubiu		op2, op, 1
	ibeq		op, vi0, texgen_box				; op 8 = box
	isubiu		op, op2, 1
	ibeq		op2, vi0, texgen_rotzoom		; op 9 = rotzoom

texgen_end:
	iaddiu		stage, vi0, 1					; enter the next stage
	isw.x		stage, status(vi0)
	--cont

; *** NOISE
	
texgen_noise:
	ilw.y		buffer, -1(scriptptr)			; load the target buffer index
	bal			ret, set_frame_to_buffer
	lq			color, -1(scriptptr)			; load color for the noise
	lq			giftag, pointgiftag(vi0)
	iaddiu		packet, vi0, free_mem
	sq			giftag, 0(packet)				; copy giftag
	sub			pos, vf0, vf0					; start position = 0, 0
	iaddiu		ycnt, vi0, 128
	
texgen_noise_y:
	iaddiu		xcnt, vi0, 128

texgen_noise_x:
	rnext		pixel, r						; get random brightness
	rnext		vf0, r
	rnext		vf0, r
	rnext.x		crom, r
	rnext		vf0, r
	rnext		vf0, r
	rnext.y		crom, r							; get random crominance
	rnext		vf0, r
	rnext		vf0, r
	sub			pixel, pixel, vf0[w]
	sub.xy		crom, crom, vf0[w]
	mul.x		crom, crom, crom
	add			one, vf0, vf0[w]
	sub.z		crom, one, crom[y]
	sub.yz		gbscale, one, crom[x]
	mul.yz		crom, crom, gbscale
	mul.xyz		crom, crom, color[w]
	mul.xyz		crom, crom, pixel
	sub.xyz		pixel, pixel, crom
	mul			pixel, pixel, color
	ftoi0		pixel, pixel
	xgkick		vi0
	sq			pixel, 1(packet)
	ftoi4		tmp, pos
	sq			tmp, 2(packet)
	xgkick		packet
	add.x		pos, pos, vf0[w]
	isubiu		xcnt, xcnt, 1
	ibne		xcnt, vi0, texgen_noise_x
	
	loi			128
	sub.x		pos, pos, i
	add.y		pos, pos, vf0[w]
	isubiu		ycnt, ycnt, 1
	ibne		ycnt, vi0, texgen_noise_y
	b			texgen_loop

; *** BLUR
	
texgen_blur:
; first copy the input buffer to the output and tmp buffers
	iaddiu		alpha, vi0, 128
	iaddiu		alpha_func, vi0, FIXEDALPHA
	bal			ret, setalpha
	iaddiu		brightness, vi0, 128
	bal			ret, setbrightness
	ilw.y		source, -1(scriptptr)
	ilw.z		dest, -1(scriptptr)
	sub.xy		offset, vf0, vf0
	bal			ret2, drawbuffer
	ilw.w		dest, -1(scriptptr)
	bal			ret2, drawbuffer
	lq.yz		fcounter, -1(scriptptr)
	ftoi0.yz	fcounter, fcounter
	mtir		xcount, fcounter[y]
	mtir		ycount, fcounter[z]
	lq.w		falpha, -1(scriptptr)
	ftoi0.w		falpha, falpha
	lq.x		shiftoffset, -1(scriptptr)
	ftoi0.x		shiftoffset, shiftoffset

; blend buffers with increasing offset
blur_loop:
	sub.y		offset_i, vf0, vf0
	add.x		offset_i, vf0, vf0[w]
	iadd		counter, vi0, xcount
	bal			ret3, blur_onedir
	sub.x		offset_i, vf0, vf0
	add.y		offset_i, vf0, vf0[w]
	iadd		counter, vi0, ycount
	bal			ret3, blur_onedir

	; next iteration blend with factor 0.5
	iaddiu		alpha, vi0, 128
	mfir.w		falpha, alpha
	mfir.x		shiftoffset, vi0
	isubiu		xcount, xcount, 1
	isubiu		ycount, ycount, 1
	ibgtz		xcount, blur_loop
	ibgtz		ycount, blur_loop

	b			texgen_loop

blur_onedir:
	ibgtz		counter, blur_skipret
	jr			ret3
blur_skipret:
; set blending
	iaddiu		alpha, vi0, 64
	iaddiu		alpha_func, vi0, ADDALPHA
	bal			ret, setalpha
	iadd		brightness, vi0, alpha
	bal			ret, setbrightness

; blend buffers
	loi			0.5
	add.xy		offset, offset_i, i
	move.xy		offset, offset_i
	ilw.z		source, -1(scriptptr)
	ilw.w		dest, -1(scriptptr)
	bal			ret2, drawbuffer

	mtir		scale, falpha[w]
	isubiu		shift, scale, 128
	isub		shift, vi0, shift
	mtir		tmp, shiftoffset[x]
	iadd		shift, shift, tmp
	ilw.w		source, -1(scriptptr)
	ilw.z		dest, -1(scriptptr)
	bal			ret4, adjustbuffer

	add.xy		offset_i, offset_i, offset_i
	isubiu		counter, counter, 1
	b			blur_onedir

; *** EMBOSS
	
texgen_emboss:
	ilw.y		source, -1(scriptptr)
	ilw.z		dest, -1(scriptptr)
	iaddiu		shift, vi0, 128
	iaddiu		scale, vi0, 64
	bal			ret4, adjustbuffer
	iaddiu		alpha_func, vi0, SRCSUBALPHA
	iaddiu		alpha, vi0, 64
	bal			ret, setalpha
	iaddiu		brightness, vi0, 128
	bal			ret, setbrightness
	loi			127
	add.xy		offset, vf0, i
	bal			ret2, drawbuffer
	b			texgen_loop

; *** ADJUST
	
texgen_adjust:
	ilw.y		source, -1(scriptptr)
	ilw.z		dest, -1(scriptptr)
	ilw.w		other, -1(scriptptr)
	lq.xy		param, -1(scriptptr)
	ftoi0.xy	param, param
	mtir		scale, param[x]
	mtir		shift, param[y]
	lq.w		count, -1(scriptptr)
	ftoi0.w		count, count
	mtir		count, count[w]
texgen_adjust_loop
	isubiu		count, count, 1
	bal			ret4, adjustbuffer
	iadd		source, vi0, dest
	iadd		dest, vi0, other
	iadd		other, vi0, source
	ibgtz		count, texgen_adjust_loop
	b			texgen_loop

; *** ADD
	
texgen_add:
	iaddiu		alpha, vi0, 128
	iaddiu		alpha_func, vi0, FIXEDALPHA
	bal			ret, setalpha
	iaddiu		brightness, vi0, 128
	bal			ret, setbrightness
	ilw.y		source, -1(scriptptr)
	ilw.w		dest, -1(scriptptr)
	sub.xy		offset, vf0, vf0
	bal			ret2, drawbuffer
	lq.xy		factors, -1(scriptptr)
	ftoi0.xy	factors, factors
	mtir		alpha, factors[x]
	iaddiu		alpha_func, vi0, ADDALPHA
	bal			ret, setalpha
	mtir		brightness, factors[y]
	bal			ret, setbrightness
	ilw.z		source, -1(scriptptr)
	bal			ret2, drawbuffer
	b			texgen_loop

; *** GREY
	
texgen_grey:
	iaddiu		alpha, vi0, 128
	iaddiu		alpha_func, vi0, FIXEDALPHA
	bal			ret, setalpha
	iaddiu		brightness, vi0, 0
	bal			ret, setbrightness
	ilw.z		buffer, -1(scriptptr)
	bal			ret, set_frame_to_buffer
	iaddiu		tmp, vi0, solidsprite
	xgkick		tmp									; draw a solid black sprite into the dest buffer
	iaddiu		alpha_func, vi0, ADDALPHA
	bal			ret, setalpha
	
	lq			scalings, -1(scriptptr)
	ftoi0		scalings, scalings
	mtir		brightness, scalings[x]
	bal			ret, setbrightness
	ilw.y		source, -1(scriptptr)
	ilw.z		dest, -1(scriptPtr)
	iaddiu		channel, vi0, 0
	bal			ret2, draw_pal_buffer
	
	lq			scalings, -1(scriptptr)
	ftoi0		scalings, scalings
	mtir		brightness, scalings[y]
	bal			ret, setbrightness
	ilw.y		source, -1(scriptptr)
	ilw.z		dest, -1(scriptPtr)
	iaddiu		channel, vi0, 1
	bal			ret2, draw_pal_buffer
	
	lq			scalings, -1(scriptptr)
	ftoi0		scalings, scalings
	mtir		brightness, scalings[z]
	bal			ret, setbrightness
	ilw.y		source, -1(scriptptr)
	ilw.z		dest, -1(scriptPtr)
	iaddiu		channel, vi0, 2
	bal			ret2, draw_pal_buffer		; i wanted to do this as a loop...
											; ... but vcl didn't
	
	b			texgen_loop

; *** MUL

texgen_mul:
	iaddiu		alpha, vi0, 128
	iaddiu		alpha_func, vi0, FIXEDALPHA
	bal			ret, setalpha
	lq.x		scale, -1(scriptptr)
	ftoi0.x		scale, scale
	mtir		brightness, scale[x]
;	iaddiu		brightness, vi0, 128
	bal			ret, setbrightness
	ilw.y		source, -1(scriptptr)
	ilw.w		dest, -1(scriptptr)
	sub			offset, vf0, vf0
	bal			ret2, drawbuffer
	iaddiu		alpha_func, vi0, MULALPHA
	bal			ret, setalpha
	ilw.z		source, -1(scriptptr)
	
	lq			channelmask, channelmasks(vi0)
	add.y		channelmask, vf0, channelmask[x]
	sq.y		channelmask, bufframepacket+1(vi0)
	iaddiu		channel, vi0, 0
	bal			ret2, draw_pal_buffer

	lq			channelmask, channelmasks(vi0)
	add.y		channelmask, vf0, channelmask[y]
	sq.y		channelmask, bufframepacket+1(vi0)
	iaddiu		channel, vi0, 1
	bal			ret2, draw_pal_buffer

	lq			channelmask, channelmasks(vi0)
	add.y		channelmask, vf0, channelmask[z]
	sq.y		channelmask, bufframepacket+1(vi0)
	iaddiu		channel, vi0, 2
	bal			ret2, draw_pal_buffer

	sq.y		vf0, bufframepacket+1(vi0)
	b			texgen_loop

; *** INVERT

texgen_invert:
	iaddiu		alpha, vi0, 128
	iaddiu		alpha_func, vi0, FIXEDALPHA
	bal			ret, setalpha
	iaddiu		brightness, vi0, 255
	bal			ret, setbrightness
	ilw.z		buffer, -1(scriptptr)
	bal			ret, set_frame_to_buffer
	iaddiu		packet, vi0, solidsprite
	xgkick		packet
	iaddiu		alpha_func, vi0, SRCSUBALPHA
	bal			ret, setalpha
	ilw.y		source, -1(scriptptr)
	ilw.z		dest, -1(scriptptr)
	sub			offset, vf0, vf0
	bal			ret2, drawbuffer
	b			texgen_loop

; *** BOX

texgen_box:
	iaddiu		alpha, vi0, 128
	iaddiu		alpha_func, vi0, FIXEDALPHA
	bal			ret, setalpha
	iaddiu		brightness, vi0, 128
	bal			ret, setbrightness
	ilw.y		buffers, -1(scriptptr)
	iaddiu		mask, vi0, 255
	iand		dest, buffers, mask
	isub		source, buffers, dest
	mfir.x		tmp, source
	itof0.x		tmp, tmp
	loi			1.0/256
	mul.x		tmp, tmp, i
	ftoi0.x		tmp, tmp
	mtir		source, tmp[x]
	sub			offset, vf0, vf0
	bal			ret2, drawbuffer
	ibne		source, vi0, texgen_box_skipclear
	iaddiu		brightness, vi0, 0
	bal			ret, setbrightness
	iaddiu		packet, vi0, solidsprite
	xgkick		packet
texgen_box_skipclear:
	ilw.z		redgreen, -1(scriptptr)
	iand		red, redgreen, mask
	isub		green, redgreen, red
	mfir.y		col, green
	itof0.y		col, col
	loi			1.0/256
	mul.y		col, col, i
	ftoi0.y		col, col
	ilw.w		blue, -1(scriptptr)
	mfir.x		col, red
	mfir.z		col, blue
	iaddiu		packet, vi0, free_mem
	lq			giftag, colortag(vi0)
	sq			giftag, 0(packet)
	sq.xyz		col, 1(packet)
	xgkick		packet
	xgkick		vi0
	lq			giftag, solidsprite(vi0)
	sq			giftag, 0(packet)
	lq			pos, -1(scriptptr)
	ftoi4		pos, pos
	mr32		pos2, pos
	mr32		pos2, pos2
	sub.zw		pos, vf0, vf0
	sub.zw		pos2, vf0, vf0
	sq			pos, 1(packet)
	sq			pos2, 2(packet)
	xgkick		packet
	xgkick		vi0
	b			texgen_loop

; *** ROTZOOM

texgen_rotzoom:
	iaddiu		alpha, vi0, 128
	iaddiu		alpha_func, vi0, FIXEDALPHA
	bal			ret, setalpha
	iaddiu		brightness, vi0, 128
	bal			ret, setbrightness
	ilw.y		buffer, -1(scriptptr)
	bal			ret, set_tex0_to_buffer
	ilw.z		buffer, -1(scriptptr)
	bal			ret, set_frame_to_buffer
	lq			params, -1(scriptptr)
	esin		p, params[z]
	loi			1.570796			; pi/2
	add.z		params, params, i
	loi			3.14159				; pi
	sub.z		tmp, params, i
	fsand		flags, 2
	ibne		flags, vi0, texgen_rotzoom_skipangleadjust
	loi			6.2831853			; 2pi
	sub.z		params, params, i
texgen_rotzoom_skipangleadjust:
	mfp.y		xvec, p
	esin		p, params[z]
	mfp.x		xvec, p
	loi			128
	mul.w		params, params, i
	mul.xy		xvec, xvec, params[w]
	add.y		yvec, vf0, xvec[x]
	sub.x		yvec, vf0, xvec[y]
	loi			0.5
	add.xy		params, params, i
	iaddiu		packet, vi0, free_mem
	lq			giftag, tristripgiftag(vi0)
	sq			giftag, 0(packet)
	ftoi4.xy	tmp, params
	sq.xy		tmp, 1(packet)
	mfir		pos, vi0
	sq			pos, 2(packet)
	add.xy		params, params, xvec
	ftoi4.xy	tmp, params
	sq.xy		tmp, 3(packet)
	iaddiu		offset, vi0, 128*16
	mfir.x		pos, offset
	sq			pos, 4(packet)
	add.xy		params, params, yvec
	ftoi4.xy	tmp, params
	sq.xy		tmp, 7(packet)
	mfir.y		pos, offset
	sq			pos, 8(packet)
	sub.xy		params, params, xvec
	ftoi4.xy	tmp, params
	sq.xy		tmp, 5(packet)
	mfir.x		pos, vi0
	sq			pos, 6(packet)
	xgkick		packet
	xgkick		vi0
	b			texgen_loop
	
setalpha:
	; in: alpha (i) - fixed alpha value
	;     alpha_func (i) - alpha blend function
	iaddiu		tmp, vi0, free_mem
	lq			tmp2, ADtag(vi0)
	sq			tmp2, 0(tmp)
	mfir.y		tmp2, alpha
	mfir.x		tmp2, alpha_func
	iaddiu		tmp3, vi0, 0x42
	mfir.z		tmp2, tmp3
	sq.xyz		tmp2, 1(tmp)
	xgkick		tmp
	xgkick		vi0
	jr			ret

setbrightness:
	; in: brightness (i) - value for the three color channels
	iaddiu		tmp, vi0, free_mem
	lq			tmp2, colortag(vi0)
	sq			tmp2, 0(tmp)
	mfir		tmp2, brightness
;	iaddiu		tmp3, vi0, 128
;	mfir.w		tmp2, tmp3
	sq			tmp2, 1(tmp)
	xgkick		tmp
	xgkick		vi0
	jr			ret

adjustbuffer:
	; in: shift  (i) - amount to add
	;     scale  (i) - scale factor
	;     source (i) - source buffer index
	;     dest   (i) - destination buffer index
	iadd		buffer, vi0, dest
	bal			ret, set_frame_to_buffer
	iaddiu		brightness, vi0, 128
	bal			ret, setbrightness
	iaddiu		alpha, vi0, 128
	iaddiu		alpha_func, vi0, FIXEDALPHA
	bal			ret, setalpha
	iaddiu		tmp, vi0, solidsprite
	xgkick		tmp									; draw a solid white sprite into the dest buffer
	iadd		brightness, vi0, scale
	bal			ret, setbrightness
	iadd		alpha, vi0, shift
	iaddiu		alpha_func, vi0, ADDALPHA
	ibgez		alpha, adjust_add
	isub		alpha, vi0, alpha
	iaddiu		alpha_func, vi0, SUBALPHA
adjust_add:
	bal			ret, setalpha
	sub.xy		offset, vf0, vf0
	bal			ret2, drawbuffer
	jr			ret4
	
drawbuffer:
	; in: offset (f) - uv offset
	;     source (i) - source buffer index
	;     dest   (i) - destination buffer index
	iadd		buffer, vi0, source
	bal			ret, set_tex0_to_buffer
	iadd		buffer, vi0, dest
	bal			ret, set_frame_to_buffer
	loi			0.5
	add.xy		tmpoffset, offset, i
	iaddiu		tmp, vi0, free_mem
	lq			tmp2, spritegiftag(vi0)
	sq			tmp2, 0(tmp)
	mfir		tmp2, vi0
	sq			tmp2, 2(tmp)
	iaddiu		tmp3, vi0, 128*16
	mfir.xy		tmp2, tmp3
	sq			tmp2, 4(tmp)
	ftoi4.xy	tmp2, tmpoffset
	sq.xy		tmp2, 1(tmp)
	loi			128
	add.xy		tmp2, tmpoffset, i
	ftoi4.xy	tmp2, tmp2
	sq.xy		tmp2, 3(tmp)
	xgkick		tmp
	xgkick		vi0
	jr			ret2

draw_pal_buffer:
	; in: source (i) - source buffer index
	;     dest   (i) - destination buffer index
	;     channel(i) - channel (rgba=>0-3) to draw
	iadd		buffer, vi0, source
	bal			ret, set_paltex0_to_buffer
	iadd		buffer, vi0, dest
	bal			ret, set_frame_to_bufferC
	iaddiu		tmp, vi0, free_mem
	lq			tmp2, spritegiftag(vi0)
	sq			tmp2, 0(tmp)
	sub			tmppos, vf0, vf0
	iaddiu		tmpmask, vi0, 1
	iand		tmpflag, channel, tmpmask
	iadd		tmp2, tmpflag, tmpflag		; starty = (channel & 1) * 2
	mfir.y		tmppos, tmp2
	iaddiu		tmpmask, vi0, 2
	iand		tmp2, channel, tmpmask
	iadd		tmp2, tmp2, tmp2
	iadd		tmp2, tmp2, tmp2			; startx = (channel & 2) * 4
	mfir.x		tmppos, tmp2
	itof0.xy	tmppos, tmppos
	loi			0.5
	add.xy		tmppos, tmppos, i
	sub			tmptpos, vf0, vf0
	sub			tmpsize, vf0, vf0
	loi			8
	add.x		tmpsize, vf0, i
	loi			2
	add.y		tmpsize, vf0, i
	move		tmphalfsize, tmpsize
	loi			4
	add.x		tmphalfsize, vf0, i
	iaddiu		tmpxcnt, vi0, 16
draw_pal_buf_xloop:
	iaddiu		tmpycnt, vi0, 64
draw_pal_buf_yloop:
	ftoi4		tmp2, tmppos
	sq			tmp2, 1(tmp)
	ibne		tmpflag, vi0, draw_pal_buf_odd
	ftoi4		tmp2, tmptpos
	sq			tmp2, 2(tmp)
	add			tmp2, tmppos, tmpsize
	ftoi4		tmp2, tmp2
	sq			tmp2, 3(tmp)
	add			tmp2, tmptpos, tmpsize
	ftoi4		tmp2, tmp2
	sq			tmp2, 4(tmp)
	xgkick		tmp
	xgkick		vi0
	b			draw_pal_buf_skipodd
draw_pal_buf_odd:
	move		tmp2, tmptpos
	add.x		tmp2, tmptpos, tmphalfsize
	ftoi4		tmp2, tmp2
	sq			tmp2, 2(tmp)
	add			tmp2, tmppos, tmphalfsize
	ftoi4		tmp2, tmp2
	sq			tmp2, 3(tmp)
	add			tmp2, tmptpos, tmpsize
	ftoi4		tmp2, tmp2
	sq			tmp2, 4(tmp)
	xgkick		tmp
	xgkick		vi0
	move		tmp2, tmppos
	add.x		tmp2, tmppos, tmphalfsize
	ftoi4		tmp2, tmp2
	sq			tmp2, 1(tmp)
	ftoi4		tmp2, tmptpos
	sq			tmp2, 2(tmp)
	add			tmp2, tmppos, tmpsize
	ftoi4		tmp2, tmp2
	sq			tmp2, 3(tmp)
	add			tmp2, tmptpos, tmphalfsize
	ftoi4		tmp2, tmp2
	sq			tmp2, 4(tmp)
	xgkick		tmp
	xgkick		vi0
draw_pal_buf_skipodd:
	isub		tmpflag, vi0, tmpflag
	iaddiu		tmpflag, tmpflag, 1				; toggle flag
	loi			4
	add.y		tmppos, tmppos, i
	loi			2
	add.y		tmptpos, tmptpos, i
	isubiu		tmpycnt, tmpycnt, 1
	ibgtz		tmpycnt, draw_pal_buf_yloop
	loi			256
	sub.y		tmppos, tmppos, i
	loi			128
	sub.y		tmptpos, tmptpos, i
	loi			16
	add.x		tmppos, tmppos, i
	loi			8
	add.x		tmptpos, tmptpos, i
	isubiu		tmpxcnt, tmpxcnt, 1
	ibgtz		tmpxcnt, draw_pal_buf_xloop
	jr			ret2

set_frame_to_buffer:
	; in: buffer (i) - buffer to set
	iaddiu		tmp, vi0, free_mem
	lq			tmp2, bufframepacket(vi0)
	sq			tmp2, 0(tmp)
	lq			tmp2, bufframepacket+1(vi0)
	sq			tmp2, 1(tmp)
	mfir.x		tmp3, buffer
	itof0.x		tmp3, tmp3
	loi			8
	mul.x		tmp3, tmp3, i
	itof0.x		tmp2, tmp2
	add.x		tmp2, tmp2, tmp3
	ftoi0.x		tmp2, tmp2
	sq.x		tmp2, 1(tmp)
	xgkick		tmp
	xgkick		vi0
	jr			ret

; this is really an exact copy of set_frame_to_buffer
; it is needed because of an vcl1.3.2 bug
set_frame_to_bufferC:
	; in: buffer (i) - buffer to set
	iaddiu		tmp, vi0, free_mem
	lq			tmp2, bufframepacket(vi0)
	sq			tmp2, 0(tmp)
	lq			tmp2, bufframepacket+1(vi0)
	sq			tmp2, 1(tmp)
	mfir.x		tmp3, buffer
	itof0.x		tmp3, tmp3
	loi			8
	mul.x		tmp3, tmp3, i
	itof0.x		tmp2, tmp2
	add.x		tmp2, tmp2, tmp3
	ftoi0.x		tmp2, tmp2
	sq.x		tmp2, 1(tmp)
	xgkick		tmp
	xgkick		vi0
	jr			ret

set_tex0_to_buffer:
	; in: buffer (i) - buffer to set
	iaddiu		tmp, vi0, free_mem
	lq			tmp2, buftex0packet(vi0)
	sq			tmp2, 0(tmp)
	lq			tmp2, buftex0packet+1(vi0)
	sq			tmp2, 1(tmp)
	mfir.x		tmp3, buffer
	itof0.x		tmp3, tmp3
	loi			0Xd4800000
	mul.x		tmp3, tmp3, i
	add.x		tmp2, tmp2, tmp3
	sq.x		tmp2, 1(tmp)
	xgkick		tmp
	xgkick		vi0
	jr			ret
	
set_paltex0_to_buffer:
	; in: buffer (i) - buffer to set
	iaddiu		tmp, vi0, free_mem
	lq			tmp2, bufpaltex0packet(vi0)
	sq			tmp2, 0(tmp)
	lq			tmp2, bufpaltex0packet+1(vi0)
	sq			tmp2, 1(tmp)
	mfir.x		tmp3, buffer
	itof0.x		tmp3, tmp3
	loi			0X19800000
	mul.x		tmp3, tmp3, i
	add.x		tmp2, tmp2, tmp3
	sq.x		tmp2, 1(tmp)
	xgkick		tmp
	xgkick		vi0
	jr			ret
	
.END
