	
	.include	"basic_vu.i"
	.include	"spad.i"
	.include	"demu.i"
	.include	"vumacros.m"



	.macro 		mk2t	num

	
	
;	XY


	mul.xy		acc,camc,w2cam[\num]
	madd.xy		w2t[\num],offset,w2cam[\num][z]

;	Z	
	mul.z		acc,w2cam[\num],camc[w]		  ; B*z+ A*w
	madd.z		w2t[\num],camc,w2cam[\num][w]

;	W
	mul.w		w2t[\num],vf00,w2cam[\num][z]	  ; .w = z
	
	sq		w2t[\num],sp_w2telly+\num(vi00)
	.endm


 	--enter
	--endenter


       	sub	lat,vf00,vf00

	ilw.x	tmp,sp_iConst1(vi00)x
	ibeq	tmp,vi00,no_lat	
	
	lq	lat,sp_fishTable(vi00)

no_lat:
	sq	lat,sp_camLookAt(vi00)


	lq	cam_control,sp_camControl(vi00)

;	R

	ilw.w	pad,sp_iConst0(vi00)
	
	loi	2.0e-1
	iaddiu	tmp,vi00,0x800
	iand	tmp,pad,tmp
	ibeq	tmp,vi00,no_rinc
	add.z	cam_control,cam_control,i
no_rinc:
	iaddiu	tmp,vi00,0x200
	iand	tmp,pad,tmp
	ibeq	tmp,vi00,no_rdec
	sub.z	cam_control,cam_control,i
no_rdec:
	lq.w	tmp,sp_fConst0(vi00)
	add.z	cam_control,cam_control,tmp[w]



;	Phi

	loi	2.0e-2

	iaddiu	tmp,vi00,0x20
	iand	tmp,pad,tmp
	ibeq	tmp,vi00,no_pinc
	add.x	cam_control,cam_control,i
no_pinc:
	iaddiu	tmp,vi00,0x80
	iand	tmp,pad,tmp
	ibeq	tmp,vi00,no_pdec
	sub.x	cam_control,cam_control,i
no_pdec:


;	Theta

	iaddiu	tmp,vi00,0x10
	iand	tmp,pad,tmp
	ibeq	tmp,vi00,no_tinc
	add.y	cam_control,cam_control,i
no_tinc:
	iaddiu	tmp,vi00,0x40
	iand	tmp,pad,tmp
	ibeq	tmp,vi00,no_tdec
	sub.y	cam_control,cam_control,i
no_tdec:

;	bump Phi anyway

	loi	1.0e-3
	add.x	cam_control,cam_control,i

;	clamp to MAX_MIN_R

	loi	40.0
	mini.z	cam_control,cam_control,i
		
	loi	2.0
	max.z	cam_control,cam_control,i

;	clamp Theta

	loi	1.0e-1
	max.y	cam_control,cam_control,i
	loi	1.9
	mini.y	cam_control,cam_control,i

;	keep Phi in range 0,4 - not for a demo..



;	store new parameters

	sq	cam_control,sp_camControl(vi00)
	



;	get sine/cosing of 
			       
	maxw		ONE,vf00,vf00	
	lq		a_const,sp_angConsts(vi00)
	lq		s_taylor,sp_sinTaylor(vi00)
	lq		c_taylor,sp_cosTaylor(vi00)

	mfir.w	      	sin,vi00			; basically, w has to be zero!
	mfir.w	      	cos,vi00			; for the mr32 at end to work..

	mulx.xy      	ssign,cam_control,a_const		; max value
	minix.xy	ssign,ssign,vf00       		; clamp above 0.0
	loi	      	-2.0
	maxi.xy      	ssign,ssign,i	 		; clamp to -2 below
	addw.xy      	ssign,ssign,vf00		; now.. -1 or 1	 !

	abs.xy		angles,cam_control			; abs value
	ftoi0.xy	iang,angles			; integer parts
	
	iaddiu 		three,vi00,3
	
	mtir	      	x_int,iang[x]
	iand   		x_int,x_int,three
	lq.x   		flip,sp_FBT(x_int)
	lq.x   		sin_sign,sp_SST(x_int)
	lq.x  		cos_sign,sp_CST(x_int)
	
	mtir	      	y_int,iang[y]
	iand   		y_int,y_int,three
	lq.y   		flip,sp_FBT(y_int)
	lq.y   		sin_sign,sp_SST(y_int)
	lq.y  		cos_sign,sp_CST(y_int)
	
	mul.xy		sin_sign,ssign,sin_sign
	
	itof0.xy	ifang,iang
	sub.xy		angles,angles,ifang	   		; angle 0-1
	
	mul.xy		ang2,angles,angles
	mul.xy		ang3,ang2,angles
	mul.xy		ang4,ang2,ang2
	mul.xy		ang5,ang3,ang2
	mul.xy		ang6,ang3,ang3
	mul.xy		ang7,ang3,ang4
	mul.xy		ang8,ang4,ang4
	mul.xy		ang9,ang5,ang4
	mul.xy		ang10,ang5,ang5
	
	mulaz.xy	acc,angles,a_const
     	maddax.xy	acc,ang3,s_taylor
     	madday.xy	acc,ang5,s_taylor
      	maddaz.xy	acc,ang7,s_taylor
       	maddw.xy	tsin,ang9,s_taylor
	
	mula.xy   	acc,ONE,ONE
	maddaw.xy	acc,ang2,a_const
	maddax.xy	acc,ang4,c_taylor
	madday.xy	acc,ang6,c_taylor
	maddaz.xy	acc,ang8,c_taylor
	maddw.xy	tcos,ang10,c_taylor
	
	sub.xy		mflip,ONE,flip
	mula.xy   	acc,tcos,flip  		; flip=1.0 if flip, else 0.0
	madd.xy   	sin,tsin,mflip
	
	mula.xy   	acc,tsin,flip  		; flip=1.0 if flip, else 0.0
	madd.xy   	cos,tcos,mflip 		
	
	mul.xy		sin,sin,sin_sign	; set correct signs
	mul.xy		cos,cos,cos_sign


	add.z		cos,vf00,sin[x]
	mul.xyz		cloc,cos,cam_control[z]
	mul.xz		cloc,cloc,sin[y]

	sq.xyz		cloc,sp_camLocation(vi00)

	
	mr32		yup,vf00
	mr32		yup,yup

	lq.xyz		lat,sp_camLookAt(vi00)
	sub.xyz		zahead,lat,cloc

	opmula.xyz	acc,yup,zahead
	opmsub.xyz	xleft,zahead,yup

	opmula.xyz	acc,zahead,xleft
	opmsub.xyz	yup,xleft,zahead

	normalise_q_x	xleft,xleft
	normalise_q_x	yup,yup
	normalise_p_y	zahead,zahead

	sq.xyz		xleft,sp_camXLeft(vi00)
	sq.xyz		yup,sp_camYup(vi00)
 	sq.xyz		zahead,sp_camZAhead(vi00)


;	transpose these 3 to w2cam

	move.x		w2cam[0],xleft
	add.y		w2cam[0],vf00,yup[x]
	add.z		w2cam[0],vf00,zahead[x]
	
	add.x		w2cam[1],vf00,xleft[y]
	move.y		w2cam[1],yup
	add.z		w2cam[1],vf00,zahead[y]
	
	
	add.x		w2cam[2],vf00,xleft[z]
	add.y		w2cam[2],vf00,yup[z]
	move.z		w2cam[2],zahead

	; set the right hand columns to 0,0,0,1

	sub.w		w2cam[0],vf00,vf00
	sub.w		w2cam[1],vf00,vf00
	sub.w		w2cam[2],vf00,vf00
	move.w		w2cam[3],vf00

	; now compute the -R.cameraloc

	mul		acc,vf00,vf00		 ; acc=0
	msub.xyz  	acc,w2cam[0],cloc[x]
	msub.xyz	acc,w2cam[1],cloc[y]
	msub.xyz	w2cam[3],w2cam[2],cloc[z]

	sq		w2cam[0],sp_w2cam(vi00)
	sq		w2cam[1],sp_w2cam+1(vi00)
	sq		w2cam[2],sp_w2cam+2(vi00)
	sq		w2cam[3],sp_w2cam+3(vi00)


	lq.y		eye,sp_fConst0(vi00)	
	lq		camc,sp_camConsts(vi00)
	mul.xy		camc,camc,eye[y]
	loi		2048
	add.xy		offset,vf00,i

	mk2t		0
	mk2t		1
	mk2t		2
	mk2t		3


	--exitm
	--endexit


