	
	.include	"basic_vu.i"
	.include	"spad.i"
	.include	"demu.i"
	.include	"vumacros.m"

	.macro	pad_check	mask,label

	ilw	pad\@,sp_iConst0(vi00)z
	iaddiu	tmp\@,vi0,\mask
	iand	tmp\@,pad\@,tmp\@
	ibeq	tmp\@,vi0,\label
	.endm


 	--enter
	--endenter


	lq	rSeed0,sp_rSeed0(vi00)
	lq	rAdd0,sp_rAdd0(vi00)
	lq	rMul0,sp_rMul0(vi00)

	lq	rSeed1,sp_rSeed1(vi00)
	lq	rAdd1,sp_rAdd1(vi00)
	lq	rMul1,sp_rMul1(vi00)
		

; handle world-change

	ilw.y	tm,sp_iConst1(vi0)
	iaddiu	tm,tm,1

	iaddiu	tmp,vi00,40*60
	ibne	tmp,tm,no_stp

	iaddiu	tm,vi0,0

	ilw.z	pad,sp_iConst0(vi0)
	iaddiu	tmp,vi0,(1<<12)|(1<<13)
	ior	pad,pad,tmp
	isw.z	pad,sp_iConst0(vi0)

no_stp:

; handle view-change

	isw.y	tm,sp_iConst1(vi0)

	iaddiu	tmp,vi0,20*60
	ibne	tmp,tm,no_cam

	ilw.z	pad,sp_iConst0(vi0)
	iaddiu	tmp,vi0,(1<<14)|(1<<13)
	ior	pad,pad,tmp
	isw.z	pad,sp_iConst0(vi0)

no_cam:
	
	; you know you're tired when you start thinking unix mv syntax is intel: mov <dst> <src>
	; which, isn't so good with no undelete...

	pad_check	(1<<13),no_flip

	ilw.x		a,sp_iConst1(vi0)
	iaddiu		tmp,vi0,1
	isub		a,tmp,a
	isw.x		a,sp_iConst1(vi0)

no_flip:


	pad_check	((1<<14)|(1<<12)),no_cam_init

	randm	r0,rSeed0,rMul0,rAdd0	

	loi	-0.5
	mul.y	r0,r0,i
	add.y	r0,r0,i
	sq.y	r0,sp_fConst0(vi0)

	loi	40.0
	mul.z	r0,r0,i
	loi	4
	add.z	r0,r0,i
	sq.z	r0,sp_camControl(vi0)

	

	loi	0.5
	sub.w	r0,r0,i
	
	move.w	pw,r0
	abs.w	pw,pw
	loi	0.25
	sub.w	pw,pw,i
	max.w	pw,pw,vf0[x]
	loi	0x7fffffff
	mul.w	pw,pw,i
	mini.w	pw,pw,vf0


	
	loi	0.3
	mul.w	r0,r0,i
	
	mul.w	r0,r0,pw
	
	sq.w	r0,sp_fConst0(vi0)



no_cam_init:


	; init if the start button thinks it was pushed..

	pad_check	(1<<12),no_init


	; load up the rand number stuff and the initial seeds

	iaddiu	fi_ptr,vi00,sp_fishTable
	iaddiu	fi_ptr_end,fi_ptr,NUM_FISH*2

	getONEu

	loixyzw	lconst,0.5,20.0,0,0

fi_loop:
	; random position
	


	randm	r0,rSeed0,rMul0,rAdd0	
	sub.xyz	r0,r0,lconst[x]
	mul.xyz	r0,r0,lconst[y]
	sq	r0,fi_pos(fi_ptr)


	; random velocity
	randm  		r1,rSeed1,rMul1,rAdd1	
	sub    		r1,r1,lconst[x]
	normalise_q_x	vel,r1
	move.w		vel,r1
	sq     		vel,fi_ahead(fi_ptr)


	iaddiu	fi_ptr,fi_ptr,fi_sizeof
	ibne	fi_ptr,fi_ptr_end,fi_loop


	; save random number stuff out again




no_init:

	sq	rSeed0,sp_rSeed0(vi00)
	sq	rSeed1,sp_rSeed1(vi00)


	--exitm
	--endexit


