/*

  Some ugly code slapped together to create data for the VU tree demo

  - jr

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "gif.h"

#define RAD_FROM_DEG(vDeg) ((float)((vDeg) * PI / 180.0f))
#define PI 3.1415926535897932384626433832795

#define XY(x,y) (((uint64)(x) << 4) | (((uint64)(y) << 4) << 32))

#define POINTS 6

typedef unsigned char uint8;
typedef unsigned int uint;
typedef unsigned int uint32;
typedef int int32;
typedef unsigned __int64 uint64;

#define GIF_DF_PACKED  0  
#define GIF_DF_REGLIST 1 
#define GIF_DF_IMAGE   2 

#define GS_PRIM_POINT     0
#define GS_PRIM_LINE      1
#define GS_PRIM_LINESTRIP 2
#define GS_PRIM_TRI       3
#define GS_PRIM_TRISTRIP  4
#define GS_PRIM_TRIFAN    5 
#define GS_PRIM_SPRITE    6

typedef struct
{
	uint8 nR;
	uint8 nPad0[3];
	uint8 nG;
	uint8 nPad1[3];
	uint8 nB;
	uint8 nPad2[3];
	uint8 nA;
	uint8 nPad3[3];

} PackedCol_t;

typedef struct
{
	float x,y,z,w;

} V3;

typedef struct
{
	V3 col[4];

} M44;

//	prim=GS_SET_PRIM(GS_PRIM_TRI, GOURAUD(1), TEXTURED(0), FOG(0), ABE(0), ALPHA(0), AA(0), CTXT(0), FIX(0));


V3     aPoints[POINTS + 1];
uint8  anTexels[64*64];
uint32 anCLUT[256];

void
CalcPoints()
{
  // Create sincos lookup table
  for (int i = 0; i < (POINTS + 1); i++)
  {
    float u = 1.0f / POINTS * i;         // [0;1]

	aPoints[i].x = (float)cos(PI * 2.0 * u);
    aPoints[i].y = 0;
	aPoints[i].z = (float)sin(PI * 2.0 * u);       // [0;2pi];
	aPoints[i].w = 1;
  }
}


M44 Translate(float x, float y, float z)
{
	M44 m;

	m.col[0].x = 1;
	m.col[0].y = 0;
	m.col[0].z = 0;
	m.col[0].w = 0;

	m.col[1].x = 0;
	m.col[1].y = 1;
	m.col[1].z = 0;
	m.col[1].w = 0;

	m.col[2].x = 0;
	m.col[2].y = 0;
	m.col[2].z = 1;
	m.col[2].w = 0;

	m.col[3].x = x;
	m.col[3].y = y;
	m.col[3].z = z;
	m.col[3].w = 1;

	return m;
}

M44 CreatePerspectiveMatrix(float scrz, float ax, float ay, float cx, float cy, float zmin, float zmax, float nearz, float farz)
{
	M44 m;
	float az, cz;

	cz = (-zmax * nearz + zmin * farz) / (-nearz + farz);
	az = farz * nearz * (-zmin + zmax) / (-nearz + farz);

	m.col[0].x = ax*scrz;
	m.col[0].y = 0;
	m.col[0].z = 0;
	m.col[0].w = 0;

	m.col[1].x = 0;
	m.col[1].y = ay*scrz;
	m.col[1].z = 0;
	m.col[1].w = 0;

	m.col[2].x = cx;
	m.col[2].y = cy;
	m.col[2].z = cz * (1.0f / 16.0f);		// So we can use FTOI4 on everything
	m.col[2].w = 1;

	m.col[3].x = 0;
	m.col[3].y = 0;
	m.col[3].z = az * (1.0f / 16.0f);		// So we can use FTOI4 on everything;
	m.col[3].w = 0;

	return m;
}


// Calc 'camera to screen coordinates' matrix
void
CalcPerspective(M44* pDest, float fScrWdth, float fScrHgt, float fDepthZ, float fFov)
{
	float xAspect = 4;
	float yAspect = 3;

	float fInvTan = (float)(1.0 / tan(fFov));
	float ax = (0.5f * fScrWdth) * fInvTan;
	float ay = ((-0.5f * fScrHgt * xAspect) * fInvTan) / yAspect;
	*pDest = CreatePerspectiveMatrix(1.0f, ax, ay, 2048, 2048, 1, fDepthZ, 1, 100);
}


typedef struct
{
	// 0
  uint32 depth;                  // Depth of tree (must be at least 1)
  float leaf_size;               // Size of leaves
  float leaf_threshhold;         // determines when to branch or when to create a leaf (controlled by branch thickness)
  float branch_radius;           // Initial branch radius

	// 1
  float branch_noise;            // between 0 and 1.. mul
  float branch_angle;            // between 0 and 1
  float branch_angle_bias;       // between 0 and 1 (spread)
  float branch_twist;            // between 0 and PI (0 and 180 degrees)

	// 2
  // Calced from other
  float left_angle;				// branch_angle * (3.141592653589f / 2) * branch_angle_bias;
  float right_angle;			// (1.0 - branch_angle) * (-3.141592653589f / 2) * branch_angle_bias;
  float left_branch_angle_precalc;	//sqrtf(1.0 - branch_angle)
  float right_branch_angle_precalc;

	// 3
  float store0;		// Default is stored here
  float store1;
  float store2;
  float store3;

  	// 4
  float store4;		// Default is stored here
  float store5;
  float store6;
  float store7;

	// 5
  uint64 anGIFTag[2];

	// 6
  uint64 anGIFTagEnd[2];

	// 7
  float objrot;
  uint32 seed;
  uint32 timer;
  uint32 init;

	// 8
  float lightdirs[12];			// 3 lightdirs * 4b		+8  (size: 3q)

	// 11
  float lightcol[12];			// 3 colours * 4b		+9

  // 14
  uint64 anGIFTagLeaf[2];

  // 15
  uint64	debug0[2];
  uint64	debug1[2];
  uint64	debug2[2];
  uint64	debug3[2];

} TreeSettings_t;

/*
[0] = d1x
[1] = d2x
[2] = d3x
[3] = 0

[4] = d1y
[1] = d2x
[2] = d3x
*/

class Output
{
  public:
	Output();

	bool Create(const char* pzFilename, const char* pzInclude);
	void Close();
	void Write(const void* pxData, int nSize);
	void WriteNoPad(const void* pxData, int nSize);
	void Pad();
	int  GetIndex();
	void AddToInclude(const void* pzLabel);

	FILE* mptFile;
	FILE* mptInclude;
	int mnData;
};

Output::Output()
{
	mptFile = 0;
	mnData = 0;
}

bool Output::Create(const char* pzFilename, const char* pzInclude)
{
	mptInclude = fopen(pzInclude, "w");
	mptFile = fopen(pzFilename, "wb");
	return (mptFile) ? true : false;
}

void Output::AddToInclude(const void* pzLabel)
{
	fprintf(mptInclude, "%s\t.assign\t%d\n", pzLabel, GetIndex() / 16);
}


void Output::Write(const void* pxData, int nSize)
{
	fwrite(pxData, nSize, 1, mptFile);
	mnData += nSize;
	Pad();
}

void Output::WriteNoPad(const void* pxData, int nSize)
{
	fwrite(pxData, nSize, 1, mptFile);
}


void Output::Pad()
{
	uint8 anPad[16];

	if (mnData & 15)
	{
		int nSize = 16 - (mnData & 15);
		memset(anPad, 0, sizeof(anPad));
		Write(anPad, nSize);
		mnData += nSize;
	}
}

void Output::Close()
{
	fclose(mptFile);
	fclose(mptInclude);
}

int Output::GetIndex()
{
	return mnData;
}

uint8 axTexGif[16384];
uint nTexGifSize;

#define ABS(a) (((a) < 0) ? (-a) : (a))

uint32 uOrgPal[256];

uint8 image[10000];

	uint uDstPtr = 0x46*4*32;
	uint uDstPtrClut = 0x46*4*32+((64*64) / (64*4)); 

void
CreateTexGif()
{
	uint32* next_page = (uint32*)anTexels;

	FILE* ptFile;

	if (ptFile = fopen("LEAF64.RAW", "rb"))
	{
		fread(image, 10000,1, ptFile);
		fclose(ptFile);
	}

	int numPal = image[13];
	uint8* pPal = &image[32];
	for (int c = 0; c < numPal; c++)
	{
		// incoming is RGB
		// PS want ABGR

//		uint32 col = (pPal[2] << 16) | (pPal[1] << 8) | (pPal[0]);
		uint32 col = (pPal[2] << 16) | (pPal[1] << 8) | (pPal[0]);
		if (col != 0xff0000)		// all blue
		{
			col |= 0xff000000;
		}

		pPal+=3;
		uOrgPal[c] = col;
	}

	int p;
	// swizzle pallette
	uint32 uPalPtr = (uint32)&anCLUT;
	for(p=0; p<256; p++)
		 ((uint32 *) uPalPtr)[(p & 231) + ((p & 8) << 1) + ((p & 16) >> 1)] = uOrgPal[p];


	uint64* pData = (uint64*)axTexGif;

	uint uQSize = (64*64)/16;
	*pData++ = GIFTAG(4, 0, 0, 0, 0, 1);	// GIFTAG(NLOOP, EOP, PRE, PRIM, FLG, NREG)
	*pData++ = GIFTAG_REGS1(AD);
//#define BITBLTBUF_SET(SBP, SBW, SPSM, DBP, DBW, DPSM)							((uint64(DPSM)<<56) | (uint64(DBW)<<48) | (uint64(DBP)<<32) | (uint64(SPSM)<<24) | (uint64(SBW)<<16) | (uint64(SBP)<<0))
	*pData++ = BITBLTBUF_SET(0, 0, 0, uDstPtr, 1, 0x13);		// 0x41a40 00000000L  (uDestPtr = dest in vram of texels)
	*pData++ = BITBLTBUF;
	*pData++ = TRXPOS_SET(0, 0, 0, 0, 0);
	*pData++ = TRXPOS;
	*pData++ = TRXREG_SET(64, 64);
	*pData++ = TRXREG;
	*pData++ = TRXDIR_SET(0);
	*pData++ = TRXDIR;
	*pData++ = GIFTAG(uQSize, 0, 0, 0, 2, 0);	// GIFTAG(NLOOP, EOP, PRE, PRIM, FLG, NREG)
	*pData++ = 0;

	uint8* pTexels = &image[32+(numPal*3)];
	memcpy(pData, pTexels, 64*64);
	pData += sizeof(anTexels) / 8;

	uint32 uQSizeClut = (16*16*4)/16;

	*pData++ = GIFTAG(4, 0, 0, 0, 0, 1);	// GIFTAG(NLOOP, EOP, PRE, PRIM, FLG, NREG)
	*pData++ = GIFTAG_REGS1(AD);
	*pData++ = BITBLTBUF_SET(0, 0, 0, uDstPtrClut, 1, 0x0);		// 0x41a40 00000000L
	*pData++ = BITBLTBUF;
	*pData++ = TRXPOS_SET(0, 0, 0, 0, 0);
	*pData++ = TRXPOS;
	*pData++ = TRXREG_SET(16, 16);
	*pData++ = TRXREG;
	*pData++ = TRXDIR_SET(0);
	*pData++ = TRXDIR;
	*pData++ = GIFTAG(uQSizeClut, 0, 0, 0, 2, 0);	// GIFTAG(NLOOP, EOP, PRE, PRIM, FLG, NREG)
	*pData++ = 0;
	memcpy(pData, anCLUT, sizeof(anCLUT));
	pData += sizeof(anCLUT) / 8;

	////////////7

	uint uNloop = 10;
	*pData++ = GIFTAG(uNloop, 1, 0, 0, 0, 1);	// GIFTAG(NLOOP, EOP, PRE, PRIM, FLG, NREG)
	*pData++ = GIFTAG_REGS1(AD);
//	*pData++ = TEST_SET(0, 0, 0, 0, 0, 0, 1, 2);	// 0x70000
	*pData++ = TEST_SET(1, 3, 128, 0, 0, 0, 1, 2);	// 0x70000
//#define TEST_SET(ATE, ATST, AREF, AFAIL, DATE, DATM, ZTE, ZTST)					((uint64(ZTST)<<17) | (uint64(ZTE)<<16) | (uint64(DATM)<<15) | (uint64(DATE)<<14) | (uint64(AFAIL)<<12) | (uint64(AREF)<<4) | (uint64(ATST)<<1) | (uint64(ATE)<<0))
	*pData++ = TEST_1;

	*pData++ = PABE_SET(1);			// fr bgrn leaf til at forsvinde hvis 0
	*pData++ = PABE;

	*pData++ = TEXA_SET(0x7f, 1, 0x81);	//     0x810000807fL
	*pData++ = TEXA;
	*pData++ = FBA_SET(0);
	*pData++ = FBA_1;
	*pData++ = 0;		// NOP data always 0
	*pData++ = 0xf;	// NOP instruction

//#define TEX1_SET(LCM, MXL, MMAG, MMIN, MTBA, L, K)		((uint64(K)<<32) | (uint64(L)<<19) | (uint64(MTBA)<<9) | (uint64(MMIN)<<6) | (uint64(MMAG)<<5) | (uint64(MXL)<<2) | (uint64(LCM)<<0))
	*pData++ = TEX1_SET(0, 0, 3, 0, 0, 0, 0);		// 0x60
	*pData++ = TEX1_1;
//#define TEX0_SET(TBP0, TBW, PSM, TW, TH, TCC, TFX, CBP, CPSM, CSM, CSA, CLD)	((uint64(CLD)<<61) | (uint64(CSA)<<56) | (uint64(CSM)<<55) | (uint64(CPSM)<<51) | (uint64(CBP)<<37) | (uint64(TFX)<<35) | (uint64(TCC)<<34) | (uint64(TH)<<30) | (uint64(TW)<<26) | (uint64(PSM)<<20) | (uint64(TBW)<<14) | (uint64(TBP0)<<0))
	*pData++ = TEX0_SET(uDstPtr, 1, 0x13, 6, 6, 1, 0, uDstPtrClut, 0, 0, 0, 1);	// 0x620011a40L
	*pData++ = TEX0_1;
	*pData++ = CLAMP_SET(0,0,0,0,0,0);
	*pData++ = CLAMP_1;
	*pData++ = COLCLAMP_SET(0x1);
	*pData++ = COLCLAMP;
	*pData++ = 0;
	*pData++ = TEXFLUSH;

	//
	nTexGifSize = (uint8*)pData - (uint8*)axTexGif;
}


uint8 LortBuf[100000];

uint64* pLort;

void RegSetup()
{
	uint64* pData = (uint64*)LortBuf;

	uint uNloop = 9;
	*pData++ = GIFTAG(uNloop, 1, 0, 0, 0, 1);	// GIFTAG(NLOOP, EOP, PRE, PRIM, FLG, NREG)
	*pData++ = GIFTAG_REGS1(AD);
//	*pData++ = TEST_SET(0, 0, 0, 0, 0, 0, 1, 2);	// 0x70000
	*pData++ = TEST_SET(1, 5, 128, 0, 0, 0, 1, 2);	// 0x70000
//#define TEST_SET(ATE, ATST, AREF, AFAIL, DATE, DATM, ZTE, ZTST)					((uint64(ZTST)<<17) | (uint64(ZTE)<<16) | (uint64(DATM)<<15) | (uint64(DATE)<<14) | (uint64(AFAIL)<<12) | (uint64(AREF)<<4) | (uint64(ATST)<<1) | (uint64(ATE)<<0))
	*pData++ = TEST_1;

	*pData++ = PABE_SET(0);			// fr bgrn leaf til at forsvinde hvis 0
	*pData++ = PABE;

	*pData++ = TEXA_SET(0x7f, 1, 0x81);	//     0x810000807fL
	*pData++ = TEXA;
	*pData++ = FBA_SET(0);
	*pData++ = FBA_1;
	*pData++ = 0;		// NOP data always 0
	*pData++ = 0xf;	// NOP instruction

//#define TEX1_SET(LCM, MXL, MMAG, MMIN, MTBA, L, K)		((uint64(K)<<32) | (uint64(L)<<19) | (uint64(MTBA)<<9) | (uint64(MMIN)<<6) | (uint64(MMAG)<<5) | (uint64(MXL)<<2) | (uint64(LCM)<<0))
	*pData++ = TEX1_SET(0, 0, 3, 0, 0, 0, 0);		// 0x60
	*pData++ = TEX1_1;
//#define TEX0_SET(TBP0, TBW, PSM, TW, TH, TCC, TFX, CBP, CPSM, CSM, CSA, CLD)	((uint64(CLD)<<61) | (uint64(CSA)<<56) | (uint64(CSM)<<55) | (uint64(CPSM)<<51) | (uint64(CBP)<<37) | (uint64(TFX)<<35) | (uint64(TCC)<<34) | (uint64(TH)<<30) | (uint64(TW)<<26) | (uint64(PSM)<<20) | (uint64(TBW)<<14) | (uint64(TBP0)<<0))
	*pData++ = TEX0_SET(uDstPtr, 1, 0x13, 6, 6, 1, 0, uDstPtrClut, 0, 0, 0, 1);	// 0x620011a40L
	*pData++ = TEX0_1;
	*pData++ = CLAMP_SET(0,0,0,0,0,0);
	*pData++ = CLAMP_1;
	*pData++ = COLCLAMP_SET(0x1);
	*pData++ = COLCLAMP;

	pLort = pData;
}

int main(int nArgc, char** apzArg)
{
	uint8 axBuf[2048];
	PackedCol_t tCol;
	PackedCol_t tCol1;
	PackedCol_t tCol2;

	memset(&tCol, 0, sizeof(tCol));
	memset(&tCol1, 0, sizeof(tCol1));
	memset(&tCol2, 0, sizeof(tCol2));

	// Leaf colours
	tCol.nR = 20;
	tCol.nG = 158;
	tCol.nB = 28;
	tCol.nA = 255;

	tCol1.nR = 15;
	tCol1.nG = 128;
	tCol1.nB = 20;
	tCol1.nA = 255;

	uint64* pDest = (uint64*)axBuf;
	{
	PackedCol_t tSky;
	PackedCol_t tGround;
	uint64 nTag;

	uint nHorz = 35;

//	#define PRIM_SET(PRIM, IIP, TME, FGE, ABE, AA1, FST, CTXT, FIX)					(PRMODE_SET(IIP, TME, FGE, ABE, AA1, FST, CTXT, FIX)|PRIM)
	uint64 nPrim = PRIM_SET(GS_PRIM_TRISTRIP, 1, 0, 0, 0, 0, 0, 0, 0);
//	uint64 nPrim = PRIM_SET(GS_PRIM_LINESTRIP, 1, 0, 0, 0, 0, 0, 0, 0);
	nTag = GIFTAG(4, 0, 1, nPrim, GIF_DF_PACKED, 2);      // GIFTAG(NLOOP, EOP, PRE, PRIM, FLG, NREG)
	*pDest++ = nTag;
	*pDest++ = (XYZ2 << 4) | RGBAQ;			// Regs used

	memset(&tSky, 0, sizeof(PackedCol_t));
	tSky.nR = 0;		//27;
	tSky.nG = 102;		//138;
	tSky.nB = 204;		//228;
	tSky.nA = 255;

	memset(&tGround, 0, sizeof(PackedCol_t));
	tGround.nR = 38;
	tGround.nG = 90;
	tGround.nB = 35;
	tGround.nA = 255;

	memcpy(pDest, &tSky, 16);
	pDest += 2;
	*pDest++ = XY(-320+2048, nHorz+2048);
	*pDest++ = 1;								// Z

	memcpy(pDest, &tSky, 16);
	pDest += 2;
	*pDest++ = XY(-320+2048, -112+2048);
	*pDest++ = 1;

	memcpy(pDest, &tSky, 16);
	pDest += 2;
	*pDest++ = XY(320+2048, nHorz+2048);
	*pDest++ = 1;

	memcpy(pDest, &tSky, 16);
	pDest += 2;
	*pDest++ = XY(320+2048, -112+2048);
	*pDest++ = 1;

	// Ground
	nTag = GIFTAG(4, 0, 1, nPrim, GIF_DF_PACKED, 2);      // GIFTAG(NLOOP, EOP, PRE, PRIM, FLG, NREG)
	*pDest++ = nTag;
	*pDest++ = (XYZ2 << 4) | RGBAQ;			// Regs used

	memcpy(pDest, &tGround, 16);
	pDest += 2;
	*pDest++ = XY(-320+2048, nHorz+2048);
	*pDest++ = 1;								// Z

	memcpy(pDest, &tGround, 16);
	pDest += 2;
	*pDest++ = XY(-320+2048, 112+2048);
	*pDest++ = 1;

	memcpy(pDest, &tGround, 16);
	pDest += 2;
	*pDest++ = XY(320+2048, nHorz+2048);
	*pDest++ = 1;

	memcpy(pDest, &tGround, 16);
	pDest += 2;
	*pDest++ = XY(320+2048, 112+2048);
	*pDest++ = 1;

	//////////////
	// Textured test
	// Draws a leaf in top right corner

//	#define PRIM_SET(PRIM, IIP, TME, FGE, ABE, AA1, FST, CTXT, FIX)
	uint64 nPrimTex = PRIM_SET(GS_PRIM_TRISTRIP, 1, 1, 0, 0, 0, 0, 0, 0);
	nTag = GIFTAG(4, 1, 1, nPrimTex, GIF_DF_PACKED, 3);      // GIFTAG(NLOOP, EOP, PRE, PRIM, FLG, NREG)
	*pDest++ = nTag;
	*pDest++ = (XYZ2 << 8) | (RGBAQ << 4) | (ST);			// Regs used

	float lort0[4] = {0,0,1,0};
	float lort1[4] = {1,0,1,0};
	float lort2[4] = {0,1,1,0};
	float lort3[4] = {1,1,1,0};

	memcpy(pDest, &lort0, 16); pDest += 2;
	memcpy(pDest, &tGround, 16);
	pDest += 2;
	*pDest++ = XY(240+2048, -100+2048);
	*pDest++ = 2;								// Z

	memcpy(pDest, &lort1, 16); pDest += 2;
	memcpy(pDest, &tGround, 16);
	pDest += 2;
	*pDest++ = XY(240+64+2048, -100+2048);
	*pDest++ = 2;

	memcpy(pDest, &lort2, 16); pDest += 2;
	memcpy(pDest, &tGround, 16);
	pDest += 2;
	*pDest++ = XY(240+2048, -100+32+2048);
	*pDest++ = 2;

	memcpy(pDest, &lort3, 16); pDest += 2;
	memcpy(pDest, &tGround, 16);
	pDest += 2;
	*pDest++ = XY(240+64+2048, -100+32+2048);
	*pDest++ = 2;
	}

	CalcPoints();
	CreateTexGif();
	RegSetup();

	M44 persp;
	CalcPerspective(&persp, 640, 224, (float)((1 << 24) - 1), RAD_FROM_DEG(45.0f));

	// Tree settings /////////////////
	TreeSettings_t tSettings;
	memset(&tSettings, 0, sizeof(tSettings));
	tSettings.depth = 12;

	tSettings.seed = 423423;

	tSettings.leaf_size = 1.5f;
	tSettings.leaf_threshhold = 0.05f;

	tSettings.branch_radius = 0.10f;
	tSettings.branch_noise = 0.5f;
	tSettings.branch_angle = 0.7f;
	tSettings.branch_angle_bias = 0.45f;
	tSettings.branch_twist = RAD_FROM_DEG(60.0f);
	memcpy(&tSettings.store0, &tSettings.depth, 8*4);

	// GIF

//	#define PRIM_SET(PRIM, IIP, TME, FGE, ABE, AA1, FST, CTXT, FIX)
	uint64 nPrim = PRIM_SET(GS_PRIM_TRISTRIP, 1, 0, 0, 0, 0, 0, 0, 0);
	tSettings.anGIFTagEnd[0] = GIFTAG((POINTS+1)*2, 1, 1, nPrim, GIF_DF_PACKED, 2);      // GIFTAG(NLOOP, EOP, PRE, PRIM, FLG, NREG)
	tSettings.anGIFTagEnd[1] = (XYZ2 << 4) | RGBAQ;

	tSettings.anGIFTag[0] = GIFTAG((POINTS+1)*2, 0, 1, nPrim, GIF_DF_PACKED, 2);      // GIFTAG(NLOOP, EOP, PRE, PRIM, FLG, NREG)
	tSettings.anGIFTag[1] = (XYZ2 << 4) | RGBAQ;

//	tSettings.anGIFTagLeaf[0] = GIFTAG(4, 1, 1, nPrim, GIF_DF_PACKED, 2);      // GIFTAG(NLOOP, EOP, PRE, PRIM, FLG, NREG)
//	tSettings.anGIFTagLeaf[1] = (XYZ2 << 4) | RGBAQ;

	{
//	#define PRIM_SET(PRIM, IIP, TME, FGE, ABE, AA1, FST, CTXT, FIX)					
//	uint64 nPrimTex = PRIM_SET(GS_PRIM_TRISTRIP, 1, 1, 0, 1, 0, 0, 0, 0);
	uint64 nPrimTex = PRIM_SET(GS_PRIM_TRISTRIP, 1, 1, 0, 0, 0, 0, 0, 0);
	tSettings.anGIFTagLeaf[0] = GIFTAG(4, 1, 1, nPrimTex, GIF_DF_PACKED, 3);    // GIFTAG(NLOOP, EOP, PRE, PRIM, FLG, NREG)
	tSettings.anGIFTagLeaf[1] = (XYZ2 << 8) | (RGBAQ << 4) | (ST);				// Regs used
	}

	//
	tSettings.lightdirs[0] = 1;

	// First light [0;1]
	tSettings.lightcol[0] = 123;  //150;
	tSettings.lightcol[1] = 89;     //150;
	tSettings.lightcol[2] = 51;   //150;

/*
	tSettings.lightcol[0] = 0.8f;
	tSettings.lightcol[1] = 0.8f;
	tSettings.lightcol[2] = 0.8f;
*/
/*
	tSettings.lightdirs[4+2] = -1;
	tSettings.lightcol[4+0] = 120.4f;
	tSettings.lightcol[4+1] = 120.4f;
	tSettings.lightcol[4+2] = 120.4f;
*/
/*
	tSettings.lightcol[4+0] = 0.2f;
	tSettings.lightcol[4+1] = 0.2f;
	tSettings.lightcol[4+2] = 0.2f;
*/
	////////////////////////////////////

	int nSize2 = sizeof(tSettings);

	M44 trans = Translate(0, -2.8f, 5);
//	M44 trans = Translate(0, -1.2f, 3);

	Output tFile;

	//
	if (tFile.Create("y:/demodata/tree.dat", "z:/code/vudemo/data.i"))
	{
		tFile.AddToInclude("SETTINGS");
		tFile.Write(&tSettings, sizeof(tSettings));

		tFile.AddToInclude("PERSPMTX");
		tFile.Write(&persp, sizeof(persp));

		tFile.AddToInclude("TRANSMTX");
		tFile.Write(&trans, sizeof(trans));

		tFile.AddToInclude("VTX");
		tFile.Write(aPoints, sizeof(aPoints));

		tFile.AddToInclude("COLOURS");
		tFile.Write(&tCol, sizeof(tCol));
		tFile.Write(&tCol1, sizeof(tCol1));

		tFile.AddToInclude("BACKGROUND");
		uint nSize = (uint)pDest - (uint)axBuf;
		tFile.Write(axBuf, nSize);

		tFile.AddToInclude("REGSETUP");
		nSize = (uint)pLort - (uint)LortBuf;
		tFile.Write(LortBuf, nSize);

		tFile.AddToInclude("PRIMBUFFER");
		tFile.AddToInclude("TEXUPLOAD");

		tFile.Write(axTexGif, nTexGifSize);

		tFile.Close();
	}
	return 0;
}

