	.macro LoadRotationAxisAngleY0 mat,vec,angles
	mul.xz		lra_v2,\vec,\vec
	sub.w		lra_invx2,vf00,lra_v2[x]						; w = (1.0f - x2)
	mul.xz		lra_vsin,\vec,\angles[z]
	sub.w		lra_invcos,vf00,\angles[w]						; (1.0f - C)
	mul.x		lra_zxOneMinusC,\vec,\vec[z]					; v.z * v.x 
	mul.x		lra_zxOneMinusC,lra_zxOneMinusC,lra_invcos[w]	; v.z * v.x * (1.0f - C);

	mul.w		lra_invx2,lra_invx2,\angles[w]					; (C * (1.0f - x2))
	add.x		\mat[0],lra_v2,lra_invx2[w]						; x2 + (C * (1.0f - x2));
	sub.y		\mat[0],vf00,lra_vsin[z]						; -zs
	add.z		\mat[0],vf00,lra_zxOneMinusC[x]
	mr32.w		\mat[0],vf00									; w = 0

	add.x		\mat[1],vf00,lra_vsin[z]
	add.y		\mat[1],vf00,\angles[w]
	sub.z		\mat[1],vf00,lra_vsin[x]
	mr32.w		\mat[1],vf00									; w = 0

	add.x		\mat[2],vf00,lra_zxOneMinusC[x]
	add.y		\mat[2],vf00,lra_vsin[x]
	sub.w		\mat[2],vf00,lra_v2[z]							; (1.0f - z2)
	mul.w		\mat[2],\mat[2],\angles[w]						; (C * (1.0f - z2))
	add.z		\mat[2],lra_v2,\mat[2][w]						; + z2
	mr32.w		\mat[2],vf00									; w = 0

	move		\mat[3],vf00
	.endm

;//--------------------------------------------------------------------
;// MatrixLoad - Load "matrix" from VU mem location "vumemlocation" +
;// "offset"
;//--------------------------------------------------------------------
   .macro   MatrixLoad4x3  matrix,offset,vumemlocation
   lq             \matrix[0], \offset+0(\vumemlocation)
   lq             \matrix[1], \offset+1(\vumemlocation)
   lq             \matrix[2], \offset+2(\vumemlocation)
   .endm

;----------------------------------- 
   .macro   MatrixMultiply4x3   matresult,matleft,matright
   mul            acc,           \matleft[0], \matright[0][x]
   madd           acc,           \matleft[1], \matright[0][y]
   madd           \matresult[0], \matleft[2], \matright[0][z]

   mul            acc,           \matleft[0], \matright[1][x]
   madd           acc,           \matleft[1], \matright[1][y]
   madd            \matresult[1],\matleft[2], \matright[1][z]

   mul            acc,           \matleft[0], \matright[2][x]
   madd           acc,           \matleft[1], \matright[2][y]
   madd           \matresult[2], \matleft[2], \matright[2][z]
   .endm
